function CallPrint(strid) {
    print_render_exe()
    let prtContent = document.getElementById(strid);
    let WinPrint = window.open('', '', 'left=50,top=50,width=700,height=600,toolbar=0,scrollbars=0,status=0');
    WinPrint.document.write('<html><head>');
    WinPrint.document.write('<link rel="stylesheet" href="/css/w3.css" media="all" >');
    WinPrint.document.write('<link rel="stylesheet" href="/css/print.css"  media="print">');
    WinPrint.document.write('</head><body onload="print();">');
    WinPrint.document.write(prtContent.innerHTML);
    WinPrint.document.write('</body></html>');
    WinPrint.document.close();
    WinPrint.focus();

    WinPrint.onafterprint = function () {
        WinPrint.close();
    };
}
function elValue(value) {

    if (value == "0") return "Включен всегда ";
    if (value == "5") return "Гашение через 5 сек ";
    if (value == "15") return "Гашение через 15 сек";
    if (value == "30") return "Гашение через 30 сек ";
    if (value == "60") return "Гашение через 60 сек ";
    if (value == "120") return "Гашение через 120 сек ";
    if (value == "180") return "Гашение через 180 сек ";
    return ''
}
function rcValue(value) {
    if (value == "0") return "запрещено";
    if (value == "1") return "только управление прибором";
    if (value == "2") return "полное управление";

    return ''
}
function dnValue(value) {
    let numberType
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === 'ds') {
            numberType = deviceJSON.config[i].subvalues[0].value
        }
    }
    if (numberType === '0') {
        if (value === '0') return "Телефон не используется";
        if (value === '1') return "ТРЕВОЖНЫЕ (дозвон с соединением: CSD)";
        if (value === '2') return "ТРЕВ. + СЛУЖЕБНЫЕ(для тревог:CSD, служебные:CSD)";
        if (value === '3') return "ТРЕВ.+ВЗЯТИЯ/СНЯТИЯ(для тревог:CSD,ВЗ/CH:CSD)";
        if (value === '4') return "ВСЕ (дозвон с соединением: CSD)";
    }
    else if (numberType === '1') {
        if (value === '0') return "Телефон не используется";
        if (value === '1') return "ТРЕВОЖНЫЕ (сначала - ГОЛОС, затем CSD)";
        if (value === '2') return "ТРЕВ. + СЛУЖЕБНЫЕ (для тревог:ГОЛОС->CSD,служебные:CSD)";
        if (value === '3') return "ТРЕВ.+ВЗЯТИЯ/СНЯТИЯ(для тревог:ГОЛОС->CSD,ВЗ/CH:CSD)";
        if (value === '4') return "ВСЕ (для тревог: ГОЛОС->CSD, прочие: CSD)";
    }
    else if (numberType === '2' || !numberType) {
        if (value === '0') return "Телефон не используется";
        if (value === '1') return "ТРЕВОЖНЫЕ  (дозвон без соединения: ГОЛОС)";
        if (value === '2') return "ТРЕВ.(ГОЛОС),   СЛУЖЕБНЫЕ - игнорируются";
        if (value === '3') return "ТРЕВ.(ГОЛОС), ВЗЯТИЯ/СНЯТИЯ - игнорируются";
        if (value === '4') return "ВСЕ (ГОЛОС), прочие - игнорируются";
    }
    if (value === '5') return "ВЗЯТИЯ (дозвон без соединения: ГОЛОС) "
    if (value === '6') return "СНЯТИЯ (дозвон без соединения: ГОЛОС)"
    if (value === '7') return "ДЕЖУРНЫЙ РЕЖИМ (дозвон без соединения: ГОЛОС) "
    return ''

}

function xxkb(numberRadio) {
    let hex = dataDevice["xxkb" + numberRadio].value
    let hextobin = ''
    const hexObj = {
        '0': '0000', '1': '1000', '2': '0100', '3': '1100', '4': '0010',
        '5': '1010', '6': '0110', '7': '1110', '8': '0001', '9': '1001', 'A': '0101', 'B': '1101', 'C': '0011',
        'D': '1011', 'E': '0111', 'F': '1111',
    }
    //Переводим hex из прибора в bin
    for (let i = 0; i < hex.length; i++) {
        el = hex[((i + 1) % 2) + (i & 0xFFFFFFFE)]
        for (const key in hexObj) {
            if (el === key) {
                hextobin += hexObj[key]
            }
        }
    }
    let allSectorHex = hextobin.split('')
    let numSection = []
    for (let i = 0; i < allSectorHex.length; i++) {
        if (allSectorHex[i] == 1) {
            numSection.push(i + 1)
        }
    }
    return numSection.join(",")
}

function lmValue(value) {
    if (DEVICEMODEL !== 'J2320' && DEVICEMODEL !== 'J2321' && DEVICEMODEL !== 'J2320') {
        if (DEVICEMODEL.charAt(1) === '2') {
            // ОО
            if (value === '7') return "Не используется";
            if (value === '1') return "охранный с задержкой(вход/выход)";
            if (value === '16') return "охранный с фикс. задержкой(вход/выход)";
            if (value === '2') return "охранный";
            if (value === '3') return "охранный, с контролем взлома";
            if (value === '4') return "охранный, с зад.на выход (ПРОХОДНОЙ)";
            if (value === '5') return "охр, с зад.на вых.(ПРОХОДНОЙ),с контр.взлома";
            if (value === '6') return "Тревожный";
            if (value === '14') return "ПАТРУЛЬ";
            if (value === '15') return "УПРАВЛЕНИЕ";
            if (DEVICEMODEL.slice(-4) === '2022') {
                if (value === '8') return "Пожарный тип (релейный)";
            }
            if (value === '17') return "Технологический";
            if (value === '18') return " Технологический (с формированием восстановления)";
        } else if (DEVICEMODEL.charAt(1) === '1') {
            // ППКОП
            if (value === '7') return "Не используется";
            if (value === '1') return "охранный с задержкой(вход/выход)";
            if (value === '16') return "охранный с фикс. задержкой(вход/выход)";
            if (value === '2') return "охранный";
            if (value === '3') return "охранный, с контролем взлома";
            if (value === '4') return "охранный, с зад.на выход (ПРОХОДНОЙ)";
            if (value === '5') return "охр, с зад.на вых.(ПРОХОДНОЙ),с контр.взлома";
            if (value === '6') return "Тревожный (КТС)";
            if (value === '14') return "ПАТРУЛЬ";
            if (value === '15') return "УПРАВЛЕНИЕ";
            if (value === '8') return "пожарный тип 1 (дымовые)";
            if (value === '9') return "пожарный тип 2 (дымовые + тепловые)";
            if (value === '10') return "пожарный тип 3 (тепловые)";
            if (value === '11') return "пожарный тип 1 + контрольный сброс";
            if (value === '12') return "пожарный тип 2 + контрольный сброс";

            if (value === '17') return "Технологический";
            if (value === '18') return "Технологический (с формированием восстановления";
        }
    } else {
        if (value === '7') return "Не используется";
        if (value === '6') return "Тревожный (КТС)";
        if (value === '14') return "ПАТРУЛЬ";
    }
}

function releValue(value) {

    const _minNewVersion = '0.1N'
    let currentVersion = ''
    for (j in deviceJSON.config) {
        if (deviceJSON.config[j].key == 'sv') {
            currentVersion = deviceJSON.config[j].subvalues[0].value +
                deviceJSON.config[j].subvalues[1].value

        }
    }

    if (saturnDevice.includes(DEVICEMODEL) && verElestaToInt(_minNewVersion) > verElestaToInt(currentVersion) && currentVersion !== '-1' && currentVersion !== '') {
        if (value == 12) return 'Не используется'
        if (value == 1) return 'Транспарант - Охрана'
        if (value == 2) return 'Лампа'
        if (value == 3) return 'Сирена 1'
        if (value == 4) return 'Сирена 2'
        if (value == 11) return 'Импульс'
    }
    else {
        if (value == 12) return 'Не используется'


        if (!saturnDevice.includes(DEVICEMODEL)) {
            if (value == 0) return 'SMS'
            if (value == 1) return 'ПЦН - Охрана'
        }
        if (value == 2) return 'Транспарант - Охрана'
        if (value == 3) return 'Лампа'
        if (value == 4) return 'Сирена 1'
        if (value == 5) return 'Сирена 2'
        if (DEVICEMODEL.slice(-4) === '2022') {
            if (value == 6) return 'ПЦН - Пожар'
            if (value == 7) return 'Транспарант - Пожар'
            if (value == 8) return 'Сирена 1 - Пожар'
            if (value == 9) return 'Сирена 2 - Пожар'
        }
        if (!saturnDevice.includes(DEVICEMODEL)) {
            if (value == 10) return 'Замок'
        }
        if (value == 11) return 'Импульс'
    }
    return '';
}

function dsValue(value) {
    if (value == "0") return "Звонок с соединением (CSD) при событии";
    if (value == "1") return "Звонок без соединения (ГОЛОС), затем с соединением";
    if (value == "2") return "Только звонок без соединения (ГОЛОС)";
    return ''
}
function dpValue(value) {
    if (value == "0") return "Автоопределение";
    if (value == "1") return "v.32";
    if (value == "4") return "v.110";
    return ''
}
function uaVAlue(value) {
    if (DEVICEMODEL !== "J2320" && DEVICEMODEL !== "J2321" && DEVICEMODEL !== "J2326") {
        if (value == "1") return "Постановка/Снятие"
        if (value == "2") return "Принуждение"
        if (value == "3") return "Контроль наряда"
        if (value == "4") return "Включение выхода управления"
        if (value == "5") return "Сервис"
    } else {
        if (value == "1") return "Сброс КТС"
        if (value == "3") return "онтроль наряда"
    }
    return ""
}

function ooValue(value) {
    if (value == 12) return 'Не используется'
    if (value == '0') return 'SMS'
    if (value == 1) return 'ПЦН - Охрана'
    if (value == 2) return 'Транспарант - Охрана'
    if (value == 3) return 'Лампа'
    if (value == 4) return 'Сирена 1'
    if (value == 5) return 'Сирена 2'
    if (value == 10) return 'Замок'
    if (value == 11) return 'Импульс'
    if (value == 13) return 'Контроль наряда'
    if (value == 14) return 'Выносной индикатор'
    if (value == 15) return 'Радиолампа'
    return ''
}
function print_render_exe() {
    let remotePass = ''
    let el = ''
    let ed = ''
    let ks1 = null
    let oa = ''
    let ks3 = null
    let ez = ''
    let bv = ''
    let om = ''
    let on = ''
    let pr = ''
    let im = ''
    let ph1 = ''
    let ph2 = ''
    let ct1 = ''
    let ct2 = ''
    let cb1 = ''
    let cb2 = ''
    let sk = ''
    let sg = ''
    let rc = ''
    let xo = null
    let xo1 = null
    let mc = ''
    let lf = ''
    let lm1 = null
    let em = ''
    let lc = ''
    let tb = ''
    let br = ''
    let dn1 = null
    let ds = ''
    let dp = ''
    let gd0 = ''
    let gd1 = ''
    let gt0 = ''
    let gt1 = ''
    let ie = ''
    let ma = ''
    let mb = ''
    let ws = ''
    let wk = ''
    let mp = ''
    let hs = ''
    let ua1 = null
    let rl1 = null
    let sn1 = null
    let su1 = null
    let oc1 = null
    let rm = ''
    let oo1 = null
    let al = ''
    let es = ''
    let ci = ''
    let ms = ''
    let ha = ''
    let gk1 = null


    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === '!!') remotePass = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'el') el = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ks1') ks1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ed') ed = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'oa') oa = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ks3') ks3 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ez') ez = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'bv') bv = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'om') om = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'on') on = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'pr') pr = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'im') im = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ph1') ph1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ph2') ph2 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ct1') ct1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ct2') ct2 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'cb1') cb1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'cb2') cb2 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'sk') sk = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'sg') sg = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'rc') rc = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'xo') xo = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'lf') lf = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'mc') mc = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'xo1') xo1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'lm1') lm1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'em') em = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'lc') lc = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'tb') tb = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'br') br = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'dn1') dn1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ds') ds = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'dp') dp = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gd') gd0 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gd') gd1 = deviceJSON.config[i].subvalues[1].value
        if (deviceJSON.config[i].key === 'gt') gt0 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ga1') ga1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ga2') ga2 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gl1') gl1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gl2') gl2 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gp1') gp1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gp2') gp2 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ie') ie = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ma') ma = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'mb') mb = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ws') ws = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'wk') wk = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'mp') mp = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ha') ha = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'hs') hs = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ua1') ua1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'rl1') rl1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'sn1') sn1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'su1') su1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'oc1') oc1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'rm') rm = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'oo1') oo1 = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'al') al = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'es') es = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ci') ci = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'ms') ms = deviceJSON.config[i].subvalues[0].value
        if (deviceJSON.config[i].key === 'gk1') gk1 = deviceJSON.config[i].subvalues[0].value
    }
    const arrGS = []
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key.indexOf("gs") != -1) {
            arrGS.push(deviceJSON.config[i].subvalues[0].value)
            arrGS.push(deviceJSON.config[i].subvalues[1].value)
        }
    }
    const arrIP = []
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key.indexOf("ip") != -1) {
            arrIP.push(deviceJSON.config[i].subvalues[0].value)
        }
    }



    let str = "";
    str += `<h2>Конфигурация устройства: (${document.getElementById("status_idDev").textContent || '0000-0000-0000'} )<hr style="margin-right:40%"></h2>`
    if (ks1 !== null) {
        str += `<p>Ключ шифрования файла:${ks1}</p>`
    }
    str += `<h2>Тип устройства: ${DEVICEINFO[DEVICEMODEL].model}</h2>`
    str += "<div style=display:flex>"
    str += "<table class='w3-table w3-table-all'> <tr>";
    str += "<td>Псевдоним</td>";
    str += `<th>${oa || '""'} </th>`;

    str += "</tr>";
    str += "<tr>";
    str += "<td>Пароль доступа</td>";
    str += `<th>${ks3 || '""'} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Пароль удаленного управления</td>";
    str += `<th>${remotePass || '""'} </th>`;
    str += "</tr> ";

    str += "  </table>";

    str += "<table class='w3-table w3-table-all'><thead><tr>";
    str += "<th>№</th>";
    str += "<th>Номер</th>";
    str += "<th>М</th>";
    str += "<th>Контроль баланса</th>";
    str += "</tr></thead><tbody>";


    str += "<tr>";
    str += "<td>1</td>";
    str += `<td>${ph1} </td>`;
    str += `<td>${ms == '0' ? '+' : '-'} </td>`;
    str += `<th> ${cb1 || 'Нет контроля'}/ ${ct1} ед</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<td>2</td>";
    str += `<td>${ph2} </td>`;
    str += `<td>${ms == '1' ? '+' : '-'} </td>`;
    str += `<th>${cb2 || 'Нет контроля'}/ ${ct2} ед</th>`;




    str += "</tr></tbody></table>";
    str += "</div>"
    ///////////
    str += "<h2>Сигнализация и индикация:</h2>"
    str += "<div style=display:flex>"
    str += "<table class='w3-table w3-table-all'> <tr>";
    str += "<td>Время работы выносной инд.</td>";
    str += `<th>${el} сек.</th>`;

    str += "</tr>";
    str += "<tr>";
    str += "<td>Работа инд. после постановки</td>";
    str += `<th>${elValue(ed)} </th>`;
    str += "</tr> ";

    str += "<tr>";
    str += "<td>Раздел выносного индикатора</td>";
    str += `<th>${ez} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Громкость встроенного зумера</td>";
    str += `<th>${bv} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Сообщение 'ВХОД'</td>";
    str += `<th>${em == '0' ? 'не формируется' : 'формируется'} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>'Дежурный режим'</td>";
    str += `<th>${om} ч. </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>'Дежурный режим' (голос)</td>";
    str += `<th>${on ? on + ' мин.' : ''}  </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Тип сигнала 'на резерве'</td>";
    str += `<th>${pr == '0' ? 'низкий' : 'высокий'} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Акселометр (уровень)</td>";
    str += `<th>${al == '0' ? 'ОТКЛЮЧЁН' : al} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Режим работы индикации</td>";
    str += `<th>${im == '0' ? 'ВКЛЮЧЕНА' : 'Гаш-е через 30 сек.'} </th>`;
    str += "</tr> ";
    str += "  </table>";



    str += "<table class='w3-table w3-table-all'> <tr>";
    str += "<td>Кодировка SMS</td>";
    str += `<th>${sk == '0' ? 'транслит' : 'кирилица'} </th>`;

    str += "</tr>";
    str += "<tr>";
    str += "<td>Режим передачи SMS</td>";
    str += `<th>${sg == '0' ? 'резервирование' : 'дублирование'} </th>`;
    str += "</tr> ";

    str += "<tr>";
    str += "<td>Управление по SMS</td>";
    str += `<th>${rcValue(rc)}</th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Задержка на выход</td>";
    str += `<th>${xo || ''} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Запрет взятия без IP</td>";
    str += `<th>${ci == '0' ? 'выключено' : 'ВКЛЮЧЕНО'} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Ведение LOG-файла</td>";
    str += `<th>${lf == '0' ? 'выключено' : 'ВКЛЮЧЕНО'} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Двойное снятие (голос)</td>";
    str += `<th>${es == '0' ? 'выключено' : 'ВКЛЮЧЕНО'} </th>`;
    str += "</tr> ";
    str += "<tr>";
    str += "<td>Ведущий канал</td>";
    str += `<th>${mc == '0' ? 'Ethernet' : 'GPRS'} </th>`;
    str += "</tr> ";
    str += "  </table>";
    str += "</div>"

    ////////////



    if (xo1 !== null) {
        str += "<div>"
        str += "<h2>Задержки на выход разделов (секунды)</h2>"
        str += "<div style='display:flex; flex-wrap: wrap;width:100%;'>"

        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("xo") != -1) {
                str += "<table style='width:20%;height:20px; margin:0; 'class='w3-table w3-table-all'>";
                str += "<tr >";
                str += "<th>№</th>";
                str += "<th>Выход</th>";
                str += "</tr>";
                str += "<tr>";
                str += `<th>${deviceJSON.config[i].key.slice(2)}</th>`;
                str += `<th>${deviceJSON.config[i].subvalues[0].value}</th>`;
                str += "</tr>";
                str += "</table>";
            }
        }
        str += "</div>"
        str += "</div>"
    }

    ////////////
    if (lm1 !== null) {
        const arrYZ = []
        const arrLA = []
        const arrZN = []
        const arrLB = []
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("yz") != -1) {
                arrYZ.push(deviceJSON.config[i].subvalues[0].value)
            }
        }
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("la") != -1) {
                arrLA.push(deviceJSON.config[i].subvalues[0].value)
            }
        }
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("zn") != -1) {
                arrZN.push(deviceJSON.config[i].subvalues[0].value)
            }
        }
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("lb") != -1) {
                arrLB.push(deviceJSON.config[i].subvalues[0].value)
            }
        }
        str += "<div>"
        str += "<h2>Шлейфы:</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>№</th>";
        str += "<th>Режим</th>";
        str += "<th>Раздел</th>";
        str += "<th>Псевдоним</th>";
        str += "</tr>";
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("lm") != -1) {
                let number = deviceJSON.config[i].key.slice(2)
                str += "<tr>";
                str += `<th>${number}${Object.keys(key_LM).length && key_LM[number].lrNumber}</th>`;
                str += `<th>${lmValue(deviceJSON.config[i].subvalues[0].value)}</th>`;
                str += `<th>${arrYZ.length && arrYZ[Number(number - 1)] || arrZN[Number(number - 1)]}</th>`;
                str += `<th>${arrLA.length && arrLA[Number(number - 1)]}</th>`;
                str += "</tr>";
            }
        }
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("lr") != -1) {
                let number = deviceJSON.config[i].key.slice(2)
                str += "<tr>";
                if (key_LM[number]) {
                    str += `<th>${number}${Object.keys(key_LM).length && key_LM[number].lrNumber}</th>`;
                    str += `<th>${lmValue(deviceJSON.config[i].subvalues[0].value)}</th>`;
                    str += `<th>${arrYZ[Number(number - 1)] || arrZN[Number(number - 1)]}</th>`;
                    str += `<th>${key_LM[number].name}</th>`;
                    str += "</tr>";
                }

            }
        }
        str += " </table>";
        str += `<span>Число повторов тревог<strong>:${lc == '0' ? 'Все тревоги' : lc}</strong></span>`;
        str += "</div>"
    }

    ////////////
    if (DEVICEMODEL.indexOf("208") != -1 || DEVICEMODEL.slice(0, 5).indexOf("202") != -1 || deviceSecondCore.includes(DEVICEMODEL)) {
        if (oo1 !== null) {
            str += "<div>"
            str += "<h4>Выходы управления:</h4>"
            str += "<table class='w3-table w3-table-all'><tr>";
            str += "<th>№ </th>";
            str += "<th>Режим</th>";
            str += "<th>Время</th>";
            str += "<th>Разделы</th>";
            str += "</tr>";
            const oqArr = []
            for (i in deviceJSON.config) {
                if (deviceJSON.config[i].key.indexOf("oq") != -1) {
                    oqArr.push(deviceJSON.config[i].subvalues[0].value)
                }
            }
            for (i in deviceJSON.config) {
                if (deviceJSON.config[i].key.indexOf("oo") != -1) {
                    if (deviceJSON.config[i].subvalues[0].value !== '12') {
                        str += "<tr>";
                        str += `<th>${deviceJSON.config[i].key.slice(2)}</th>`;
                        str += `<th>${ooValue(deviceJSON.config[i].subvalues[0].value)}</th>`;
                        str += `<th>${deviceJSON.config[i].subvalues[1].value}</th>`;
                        str += `<th>${oqArr[deviceJSON.config[i].key.slice(2) - 1]}</th>`;
                        str += "</tr>";
                    }
                }
            }
            str += " </table>";
            str += "</div>"

        }
    }
    if (DEVICEMODEL.indexOf("208") != -1 || DEVICEMODEL.slice(0, 5).indexOf("202") != -1) {
        if (oo1 !== null) {
            str += "<div>"
            str += "<h2>Список радиоканальных устройств:</h2>"
            str += "<table class='w3-table w3-table-all'><tr>";
            str += "<th>№ </th>";
            str += "<th>Название</th>";
            str += "<th>Серийный номер</th>";
            str += "<th>Зоны</th>";
            str += "<th>Разделы</th>";
            str += "</tr>";
            const ZYObject = {}
            for (i in deviceJSON.config) {
                if (deviceJSON.config[i].key.indexOf("yz") != -1 && deviceJSON.config[i].subvalues[0].value !== '0' && deviceJSON.config[i].subvalues[0].value !== '') {
                    let key = deviceJSON.config[i].key.slice(2)
                    let value = deviceJSON.config[i].subvalues[0].value
                    ZYObject[key] = value
                }
            }


            for (let i = 0; i < virtualRadio.length; i++) {
                const { numberRadio, serial, zone_1, zone_2, name, } = virtualRadio[i]
                let nameDevice = R_DEVICE_NAME[name].name
                str += "<tr>";
                str += `<th>${numberRadio}</th>`;
                str += `<th>${nameDevice}</th>`;
                str += `<th>${serial}</th>`;
                if (nameDevice !== 'Бр Ю-6370' && nameDevice !== 'РО Ю-3438' && nameDevice !== 'Кл Ю-6270') {
                    str += `<th> ${zone_1}${zone_2 !== '0' ? ', ' + zone_2 : ''} </th> `;
                    str += `<th>${ZYObject[zone_1] ? ZYObject[zone_1] : ''}${ZYObject[zone_2] ? ',' + ZYObject[zone_2] : ''}</th> `;
                } else if (nameDevice === 'Кл Ю-6270') {
                    str += `<th>-</th>`
                    str += `<th>${xxkb(numberRadio)}</th> `;
                }
                else {
                    str += `<th>-</th>`
                    str += `<th>-</th>`
                }
                str += "</tr>";
            }
            str += " </table>";
            str += "</div>"

        }
    }

    ////////////
    if (oc1 !== null) {
        str += "<div>"
        str += "<h2>Открытый коллектор:</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>№ </th>";
        str += "<th>Режим</th>";
        str += "<th>Время</th>";
        str += "<th>Разделы</th>";
        str += "</tr>";
        const ozArr = []
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("oz") != -1) {
                ozArr.push(deviceJSON.config[i].subvalues[0].value)
            }
        }
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("oc") != -1) {
                str += "<tr>";
                str += `<th> ${deviceJSON.config[i].key.slice(2)}</th> `;
                str += `<th> ${releValue(deviceJSON.config[i].subvalues[0].value)}</th> `;
                str += `<th> ${deviceJSON.config[i].subvalues[1].value}</th>`;
                str += `<th> ${ozArr[deviceJSON.config[i].key.slice(2) - 1]}</th>`;
                str += "</tr>";
            }
        }
        str += " </table>";
        str += "</div>"
    }

    ////////////
    if (rm) {
        str += "<div>"
        str += "<h2>Реле:</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>№ </th>";
        str += "<th>Режим</th>";
        str += "<th>Впемя</th>";
        str += "<th>Разделы</th>";
        str += "</tr>";
        /*  for (i in deviceJSON.config) {
             if (deviceJSON.config[i].key.indexOf("rm") != -1) {
                 str += "<tr>";
                 str += "<th>P1</th>";
                 str += `< th > ${ releValue(deviceJSON.config[i].subvalues[0].value) }</th > `;
                 str += `< th > ${ deviceJSON.config[i].subvalues[1].value }</th > `;
                 str += "<th>1</th>";
                 str += "</tr>";
             }
         } */
        for (let i = 0; i < THIS_DEVICE.rele.length; i++) {
            str += "<tr>";
            str += `<th> ${THIS_DEVICE.rele[i].number}</th > `;
            str += `<th> ${releValue(THIS_DEVICE.rele[i].mode)}</th > `;
            str += `<th> ${THIS_DEVICE.rele[i].time}</th > `;
            str += `<th> ${THIS_DEVICE.rele[i].section}</th> `;
            str += "</tr>";
        }

        str += " </table>";
        str += `<span> Реле при нарушении КТС <strong>:${br == '0' ? 'Выкл' : 'Вкл'}</strong ></span> `;
        str += `<span style = 'margin-left:25px'> Реле при нарушении тамперов <strong>:${tb == '0' ? 'Выкл' : 'Вкл'}</strong></span > `;
        str += "</div>"
    }

    ////////////
    if (su1 !== null) {
        str += "<div>"
        str += "<h2>Передача SMS-сообщений по ключам:</h2>"
        str += "<table style='width:50%' class='w3-table w3-table-all'><tr>";
        str += "<th>№</th>";
        str += "<th>Телефон</th>";
        str += "<th>Ключи</th>";
        str += "</tr>";
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("su") != -1 && deviceJSON.config[i].key.length < 5) {
                str += "<tr>";
                str += `<th> ${deviceJSON.config[i].key.slice(2)}</> `;
                str += `<th> ${deviceJSON.config[i].subvalues[1].value}</> `;
                str += `<th> ${deviceJSON.config[i].subvalues[0].value}</> `;
                str += "</tr>";
            }
        }
        str += "</table>";
        str += "</div>"
    }

    ////////////
    if (sn1 !== null) {
        str += "<div>"
        str += "<h2>Передача SMS-сообщений:</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>№</th>";
        str += "<th>Телефон</th>";
        str += "<th>Набор сообщений</th>";
        str += "<th>Разделы</th>";
        str += "</tr>";
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("sn") != -1) {
                let number = deviceJSON.config[i].key.slice(2)
                str += "<tr>";
                str += `<th> ${number}</th> `;
                str += `<th> ${deviceJSON.config[i].subvalues[1].value}</th> `;
                str += `<th> ${Object.keys(key_SO).length &&
                    key_SO[number].sms}</th> `;
                str += `<th> ${Object.keys(key_SO).length &&
                    key_SO[number].sections}</th> `;
                str += "</tr>";

            }
        }
        str += "</table>";

        str += "<div style='display:flex; flex-direction: column;  font-size:12px'>"
        str += " <h2> Коды типов сообщений:</h2>"
        str += " <span> <em>[01]</em> ТРЕВОЖНЫЕ</span>"
        str += " <span> <em>[03]</em> ВЗЯТИЯ/СНЯТИЯ</span>"
        str += " <span> <em>[04]</em> ЭНИЗКИЙ БАЛАНС'</span>"
        str += " <span> <em>[05]</em> ПИТАНИЕ</span>"
        str += " <span> <em>[06]</em> 'ВХОД'</span>"
        str += " <span> <em>[07]</em> 'ПАТРУЛЬ'</span>"
        str += " <span> <em>[08]</em> 'ТИХАЯ ТРЕВОГА'</span>"
        str += " <span> <em>[09]</em> СЕРВИСНЫЕ</span>"
        str += " <span> <em>[10]</em> КОНФИГУРАЦИЯ И СОСТОЯНИЕ</span>"
        str += " <span> <em>[11]</em> СБРОС</span>"
        str += " <span> <em>[12]</em> КАНАДЫ СВЯЗИ</span>"
        str += " <span> <em>[13]</em> 'ДЕЖУРНЫЙ РЕЖИМ'</span>"
        str += "</div>"
        str += "</div>"
    }

    ////////////
    if (dn1 !== null) {
        str += "<div>"
        str += "<h2>Передача псообщений по дозвону:</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>№</th>";
        str += "<th>Телефон</th>";
        str += "<th>Набор сообщений</th>";
        str += "</tr>";
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("dn") != -1) {
                str += "<tr>";
                str += `<th> ${deviceJSON.config[i].key.slice(2)}</th> `;
                str += `<th> ${deviceJSON.config[i].subvalues[1].value}</th> `;
                str += `<th> ${dnValue(deviceJSON.config[i].subvalues[0].value)}</th> `;
                str += "</tr>";
            }
        }
        str += "</table>";
        if (ds) {
            str += ` < span > Способ передачи тревожных сообщ < strong >:${dsValue(ds)}</strong ></span > <br> `;
        }
        if (dp) {
            str += `<span>Протокол для соединения по CSD<strong>:${dpValue(dp)}</strong></span>`;
        }
        str += "</div>"
    }

    ////////////
    str += "<div style='display:flex; justify-content: space-between;'>"

    if (gk1) {
        str += "<div style='display:flex; flex-direction: column; '>"
        str += "<h2>Параметры IP/UDP-связи:</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>Индификатор</th>";
        str += `<th>${hexValueGI}</th>`;
        str += "</tr>";

        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("gk") != -1) {
                str += "<tr>";
                if (deviceJSON.config[i].key === 'gk1') {
                    str += "<th>Ключи шифрации</th>";
                } else {
                    str += "<th></th>";
                }
                str += `<th>${deviceJSON.config[i].subvalues[0].value}</th>`;
                str += "</tr>";
            }
        }
        str += " </table>";
        str += "</div>"
    }


    ////////////
    str += "<div style='display:flex; flex-direction: column; '>"
    str += "<h2>Параметры сеансов связи:</h2>"
    str += "<table class='w3-table w3-table-all'><tr>";
    str += "<th>Период сообщ. 'деж.реж' тип 1</th>";
    str += `<th>${gd0} сек.</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Период сообщ. 'деж.реж' тип 2</th>";
    str += `<th>${gd1} сек.</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Время ожидания ответа</th>";
    str += `<th>${gt0} сек.</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Макс число неотв. на сообщ.</th>";
    str += `<th>${gt1}</th>`;
    str += "</tr></table>";
    str += "</div>"
    str += "</div>"

    ////////////
    str += "<div>"
    str += "<h2>Параметры GPRS-подключения:</h2>"
    str += "<table class='w3-table w3-table-all'><tr>";
    str += "<th>Параметр</th>";
    str += "<th>SIM-карта №1: (ВЕДУЩАЯ)</th>";
    str += "<th>SIM-карта №2</th>";
    str += "</tr>";
    str += "<tr>";
    str += "<th>APN-сервер</th>";
    str += `<th>${ga1 ? ga1 : `[ВЫКЛЮЧИНО]`}</th>`;
    str += `<th>${ga2 ? ga2 : `[ВЫКЛЮЧИНО]`}</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Логин</th>";
    str += `<th>${gl1 ? gl1 : `[ВЫКЛЮЧИНО]`}</th>`;
    str += `<th>${gl2 ? gl2 : `[ВЫКЛЮЧИНО]`}</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Пароль</th>";
    str += `<th>${gp1 ? gp1 : `[ВЫКЛЮЧИНО]`}</th>`;
    str += `<th>${gp2 ? gp2 : `[ВЫКЛЮЧИНО]`}</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Сервер 1</th>";
    str += `<th>${arrGS[0] ? arrGS[0] + ':' + arrGS[1] : `[ВЫКЛЮЧИНО]`}</th > `;
    str += `<th>${arrGS[2] ? arrGS[2] + ':' + arrGS[3] : `[ВЫКЛЮЧИНО]`}</th> `;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Сервер 2</th>";
    str += `<th>${arrGS[4] ? arrGS[4] + ':' + arrGS[5] : `[ВЫКЛЮЧИНО]`}</th>`;
    str += `<th>${arrGS[6] ? arrGS[6] + ':' + arrGS[7] : `[ВЫКЛЮЧИНО]`}</th> `;
    str += "</tr>";
    str += "<tr>";
    str += "<th>Сервер 3</th>";
    str += `<th>${arrGS[8] ? arrGS[8] + ':' + arrGS[9] : `[ВЫКЛЮЧИНО]`}</th> `;
    str += `<th>${arrGS[10] ? arrGS[10] + ':' + arrGS[11] : `[ВЫКЛЮЧИНО]`}</th> `;
    str += "</tr></table>";
    str += "</div>"

    ////////////
    if (arrGS.length >= 12) {
        str += "<div>"
        str += `<h2>Параметры подключения к локальной сети: ${ie == '1' ? '[ВКЛ]' : '[ВЫКЛЮЧЕНО]'
            }</h2 > `
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>Параметр</th>";
        str += "<th>Значение</th>";
        str += "</tr>";
        str += "<th>Сервер 1</th>";
        str += `<th> ${arrGS[12] ? arrGS[12] + ':' + arrGS[13] : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>Сервер 2</th>";
        str += `<th> ${arrGS[14] ? arrGS[14] + ':' + arrGS[15] : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>Сервер 3</th>";
        str += `<th> ${arrGS[16] ? arrGS[16] + ':' + arrGS[17] : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr></table>";
        str += "</div>"
    }


    ////////////
    if (arrIP.length !== 0) {
        str += "<div>"
        str += `<h2>Параметры Ethernet-подключения к локальной сети: ${ie == '1' ? `[MAC: ${ma}]` : '[ВЫКЛЮЧЕНО]'
            }</h2>`
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>Параметр</th>";
        str += "<th>Значение</th>";
        str += "</tr>";
        str += "<tr>";
        str += "<th>IP-адрес</th>";
        str += `<th> ${arrIP[0] ? arrIP[0] : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>Маска сети</th>";
        str += `<th> ${arrIP[2] ? arrIP[2] : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>Шлюз</th>";
        str += `<th> ${arrIP[1] ? arrIP[1] : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>DNS-сервер</th>";
        str += `<th> ${arrIP[3] ? arrIP[3] : `[ВЫКЛЮЧИНО]`}</th `;
        str += "</tr></table>";
        str += "</div>"
    }
    ////////////
    if (ws) {
        str += "<div>"
        str += `<h2>Параметры Wi-Fi -подключения к локальной сети:${ie == '2' ? `[MAC: ${mb}]` : '[ВЫКЛЮЧЕНО]'
            } </h2>`
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>Параметр</th>";
        str += "<th>Значение</th>";
        str += "</tr>";
        str += "<tr>";
        str += "<th>IP-адрес</th>";
        str += `<th> ${ws ? ws : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>Пароль сети</th>";
        str += `<th> ${wk ? wk : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr>";
        str += "<tr>";
        str += "<th>MAC AP-сети</th>";
        str += `<th> ${mp ? mp : `[ВЫКЛЮЧИНО]`}</th> `;
        str += "</tr></table>";
        str += "</div>"
    }

    ////////////
    if (rl1 !== null) {
        str += "<div>"
        str += "<h2>Расширители:</h2>"
        str += "<div style='display:flex'>";
        str += "<table style='width:100%; margin:0;' class='w3-table w3-table-all'><tr>";
        str += "<th>№</th>";
        str += "<th>Тип расширителя</th>";
        str += "<th>Р</th>";
        str += "<th>Н</th>";
        str += "<th>Ш/Р</th>";
        str += "</tr>";
        if (DEVICEMODEL.indexOf("208") != -1 || DEVICEMODEL.slice(0, 5).indexOf("202") != -1) {
            for (let i = 0; i < virtualExt.length; i++) {
                const { number, type, soft, sections } = virtualExt[i]
                str += "<tr>";
                str += `<th>${number}</th>`;
                str += `<td>${type + ` (ver.${soft})`}</td>`;
                str += `<td>-</td>`;
                str += `<td>-</td>`;
                str += `<td>${sections}</td>`;
                str += "</tr>";

            }
        }
        else {
            const raArrBegin = []
            const rbArrBegin = []
            const raArrParams = []
            const rbArrParams = []
            for (l in deviceJSON.config) {
                if (deviceJSON.config[l].key.indexOf("ra") != -1) {
                    raArrBegin.push(deviceJSON.config[l].subvalues[0].value)
                    raArrParams.push(deviceJSON.config[l].subvalues[1].value)
                }
            }
            for (j in deviceJSON.config) {
                if (deviceJSON.config[j].key.indexOf("rb") != -1) {
                    rbArrBegin.push(deviceJSON.config[j].subvalues[0].value)
                    rbArrParams.push(deviceJSON.config[j].subvalues[1].value)
                }
            }
            for (i in deviceJSON.config) {
                if (deviceJSON.config[i].key.indexOf("rl") != -1) {
                    let value = deviceJSON.config[i].subvalues[0].value
                    let number = deviceJSON.config[i].key.slice(2)
                    if (Number(number) <= 16) {
                        let version = deviceJSON.config[i].subvalues[1].value
                        str += "<tr>";
                        str += `<th>${number}</th>`;
                        str += `<td>${value == '0' || value == '' ? 'не подключен' : RS485[value].title + ` (ver.${version})`}</td>`;
                        str += `<td>-</td>`;
                        if (raArrParams[number - 1] !== '0' && raArrBegin[number - 1] !== '0') {
                            str += `<td>${raArrParams[number - 1]}</td>`;
                            str += `<td>${raArrBegin[number - 1]}</td>`;
                        } else {
                            if (rbArrParams[number - 1] !== '0' && rbArrBegin[number - 1] !== '0') {
                                str += `<td>${rbArrParams[number - 1]}</td>`;
                                str += `<td>${rbArrBegin[number - 1]}</td>`;
                            } else {
                                str += `<td>-</td>`;
                                str += `<td>-</td>`;
                            }

                        }

                        str += "</tr>";
                    }
                }
            }
            str += "</table>";

            str += "<table  style='width:100%; margin:0;' class='w3-table w3-table-all'><tr>";
            str += "<th>№</th>";
            str += "<th>Тип расширителя</th>";
            str += "<th>Р</th>";
            str += "<th>Н</th>";
            str += "<th>Ш/Р</th>";
            str += "</tr>";
            for (i in deviceJSON.config) {
                if (deviceJSON.config[i].key.indexOf("rl") != -1) {
                    let value = deviceJSON.config[i].subvalues[0].value
                    let number = deviceJSON.config[i].key.slice(2)
                    if (Number(number) > 16) {
                        let version = deviceJSON.config[i].subvalues[1].value
                        str += "<tr>";
                        str += `<th>${number}</th>`;
                        str += `<td>${value == '0' || value == '' ? 'не подключен' : RS485[value].title + ` (ver.${version})`}</td>`;
                        str += `<td>-</td>`;
                        if (raArrParams[number - 1] !== '0' && raArrBegin[number - 1] !== '0') {
                            str += `<td>${raArrParams[number - 1]}</td>`;
                            str += `<td>${raArrBegin[number - 1]}</td>`;
                        } else {
                            if (rbArrParams[number - 1] !== '0' && rbArrBegin[number - 1] !== '0') {
                                str += `<td>${rbArrParams[number - 1]}</td>`;
                                str += `<td>${rbArrBegin[number - 1]}</td>`;
                            } else {
                                str += `<td>-</td>`;
                                str += `<td>-</td>`;
                            }

                        }

                        str += "</tr>";
                    }
                }
            }
        }

        str += "</table>";
        str += "</div>";
        str += "</div>";
    }

    ////////////
    if (ua1 !== null) {
        str += "<div>"
        str += "<h2>Коды пользователей::</h2>"
        str += "<table class='w3-table w3-table-all'><tr>";
        str += "<th>№</th>";
        str += "<th>Псевдоним:</th>";
        str += "<th>Тип</th>";
        str += "<th>Код ключа</th>";
        str += "<th>Разделы</th>";
        str += "</tr>";
        let freeKey = 0
        const arrUZ = []
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("uz") != -1) {
                arrUZ.push(deviceJSON.config[i].subvalues[0].value)
            }
        }
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("ua") != -1) {
                if (deviceJSON.config[i].subvalues[2].value !== '') {
                    str += "<tr>";
                    str += `<th>${deviceJSON.config[i].key.slice(2)}</th>`;
                    str += `<th>${deviceJSON.config[i].subvalues[1].value}</th>`;
                    str += `<th>${uaVAlue(deviceJSON.config[i].subvalues[0].value)}</th>`;
                    str += `<th>${deviceJSON.config[i].subvalues[2].value.split("").reverse().join("")}</th>`;
                    str += `<th>${arrUZ[deviceJSON.config[i].key.slice(2) - 1]}</th>`;
                    str += "</tr>";
                } else {
                    freeKey++
                }
            }
        }
        if (freeKey === 250) {
            str += "<tr>";
            str += `<th>1</th>`;
            str += `<th></th>`;
            str += `<th>Постоновка/Снятие</th>`;
            str += `<th></th>`;
            str += `<th></th>`;
            str += "</tr>";
            str += "<tr>";
            str += `<th>...</th>`;
            str += `<th>...</th>`;
            str += `<th>...</th>`;
            str += `<th>...</th>`;
            str += `<th>...</th>`;
            str += "</tr>";
            str += "<tr>";
            str += `<th>250</th>`;
            str += `<th></th>`;
            str += `<th>Постоновка/Снятие</th>`;
            str += `<th></th>`;
            str += `<th></th>`;
            str += "</tr>";

        }

        str += "</table>";
        str += "<div>"
    }



    ////////////
    const CurrentVersionDevice = document.getElementById("status_modem_tab").textContent
    str += "<div>"
    str += "<h2 style='margin-top:80px'>Параметры обновления ПО:</h2>"
    str += "<table class='w3-table w3-table-all'><tr>";
    str += "<th>Параметр:</th>";
    str += "<th>Значение:</th>";
    str += "</tr>";
    str += "<tr>";
    str += "<td>Текущая версия</td>";
    str += `<th>${CurrentVersionDevice}</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<td>Проверка обновления</td>";
    str += `<th>${ha == '1' ? '[ВКЛ]' : '[ВЫКЛЮЧЕНО]'}</th>`;
    str += "</tr>";
    str += "<tr>";
    str += "<td>Домен обновления ПО</td>";
    str += `<th>${hs}</th>`;
    str += "</tr></table>";

    str += "<div style='display:flex; justify-content: space-between; margin-top:50px'>"
    const date = new Date();
    const dd = String(date.getDate()).padStart(2, '0');
    const mm = String(date.getMonth() + 1).padStart(2, '0');
    const yyyy = date.getFullYear();
    today = mm + '.' + dd + '.' + yyyy;
    str += `<span>Дата печати: ${today}</span>`
    str += "<div style='display:flex; justify-content: space-between; width:400px'>"
    str += "<div>Подпись:</div>"
    str += "<div>/</div>"
    str += "<div>/</div>"
    str += "</div>"
    str += "</div>"
    str += "</div>"

    document.getElementById("print-content").innerHTML = str;
}

