
let binFlag = checkBolean(localStorage.getItem('binFlag'))
let autoIP = checkBolean(localStorage.getItem('autoIP'))
let autoDNS = checkBolean(localStorage.getItem('autoDNS'))

function checkBolean(value) {
  if (typeof value === 'string') {
    return JSON.parse(value)
  }
  return null
}
function checkIP() {
  if (autoIP === null) {
    let allZeroIP = 0
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == 'ip1' || deviceJSON.config[i].key == 'ip2' || deviceJSON.config[i].key == 'ip3') {

        let tmp = Number(deviceJSON.config[i].subvalues[0].value.replaceAll(',', ''))
        if (tmp !== 0)
          allZeroIP++
      }
    }
    if (allZeroIP === 0) {
      autoIP = true
    } else {
      autoIP = false
    }
  }
}
function checkDNS() {
  if (autoDNS === null) {
    let allZeroDNS = 0
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == 'ip4') {
        let tmp = Number(deviceJSON.config[i].subvalues[0].value.replaceAll(',', ''))
        if (tmp !== 0)
          allZeroDNS++
      }
    }
    if (allZeroDNS === 0) {
      autoDNS = true
    } else {
      autoDNS = false
    }
  }
}


let timer = null
function change_so_sms_section(data) {
  let sec = data.name;
  let key = "so" + data.parentElement.parentElement.id.slice(14);
  let inputCollection = data.parentElement.parentElement.getElementsByTagName("input");
  let valueJson = "";
  if (data.name == "0") {
    for (var i = 0; inputCollection.length > i; i++) {
      if (data.checked) {
        inputCollection[i].checked = true;
        valueJson = "1,3,4,5,6,7,8,9,10,11,12,13";
      } else {
        valueJson = "";
        inputCollection[i].checked = false;
      }
    }
  } else if (data.name == "-1") {
    for (var i = 0; inputCollection.length > i; i++) {
      if (inputCollection[i].name == "1" || inputCollection[i].name == "3" || inputCollection[i].name == "5")
        if (data.checked) {
          inputCollection[i].checked = true;
        } else {
          inputCollection[i].checked = false;
        }
    }
    for (var i = 0; inputCollection.length > i; i++) {
      if (inputCollection[i].checked) {
        if ((inputCollection[i].name != "-1") & (inputCollection[i].name != "0")) {
          if (valueJson == "") {
            valueJson += inputCollection[i].name;
          } else {
            valueJson += "," + inputCollection[i].name;
          }
        }
      }
    }
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      valueJson = deviceJSON.config[i].subvalues[1].value;
    }
  }

  if (data.checked) {
    if (valueJson == "") {
      valueJson = sec;
    } else {
      valueJson += "," + sec;
    }
  } else {
    const newValueJson = valueJson.split(',').filter(val => val != sec).join()
    valueJson = newValueJson
    // valueJson = valueJson.replace("," + sec, "");
    // valueJson = valueJson.replace(sec + ",", "");
    // valueJson = valueJson.replace(sec, "");
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = valueJson;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function change_su_sms_section(data) {
  let sec = data.name;
  let key = "su" + data.parentElement.parentElement.parentElement.id.slice(14);
  let inputCollection = data.parentElement.parentElement.getElementsByTagName("input");
  let valueJson = "";

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      valueJson = deviceJSON.config[i].subvalues[0].value;
    }
  }

  if (data.checked) {
    if (valueJson == "") {
      valueJson = sec;
    } else {
      valueJson += "," + sec;
    }
  } else {
    const newValueJson = valueJson.split(',').filter(val => Number(val) != sec).join()
    valueJson = newValueJson
    // valueJson = valueJson.replace("," + sec, "");
    // valueJson = valueJson.replace(sec + ",", "");
    // valueJson = valueJson.replace(sec, "");
  }

  let lengthSuKey = valueJson.split(",");
  if (lengthSuKey.length > 5) {
    data.checked = false;
  } else {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = valueJson;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function set_CONTROL_SU_phone(data) {
  // сохранение привязки к разделам смс
  if (data.value.length <= 15) {
    let param = data.value;
    let key = "su" + data.name;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    data.value = data.value.slice(0, -1);
  }
}

function set_cannel_transiver(data) {
  let cannel = data.name;
  let param = data.value;

  if (cannel == 1 && param < 3) {
    param = "4";
  }

  let key = "xxcc";

  if (cannel == 1) {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else if (cannel == 2) {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function set_mac_radio(data) {
  let cannel = data.name;
  let param = data.value;
  let key = "xxmn";

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function set_CONTROL_SO_sec(data) {
  // сохранение привязки к разделам смс

  let param = data.value;
  let key = "so" + data.name;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function set_CONTROL_SN(data) {
  if (data.value.length <= 15) {
    let param = data.value.replace(/[^0-9+]/g, '');
    data.value = param
    let key = "sn" + data.name;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    data.value = data.value.slice(0, -1);
  }
}

function change_so_sms(data) {
  let sec = data.name;
  if ((sec != "0") & (sec != "-1")) {
    let key = "so" + data.parentElement.parentElement.id.slice(10);
    let valueJson = "";

    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        valueJson = deviceJSON.config[i].subvalues[0].value;
      }
    }

    if (data.checked) {
      if (valueJson == "") {
        valueJson = sec;
      } else {
        valueJson += "," + sec;
      }
    } else {
      const newValueJson = valueJson.split(',').filter(val => val != sec).join()
      valueJson = newValueJson
      // valueJson = valueJson.replace("," + sec, "");
      // valueJson = valueJson.replace(sec + ",", "");
      // valueJson = valueJson.replace(sec, "");
    }
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = valueJson;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
  else {
    change_so_smsEXTRA(data);
  }
}

function change_so_sms_kts(data) {
  let key = "sn" + data.name;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = data.value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function change_so_smsEXTRA(data) {
  //
  let sec = data.name;
  let key = "so" + data.parentElement.parentElement.id.slice(10);
  let inputCollection = data.parentElement.parentElement.getElementsByTagName("input");
  let valueJson = "";


  if (data.name == "0") {
    for (var i = 0; inputCollection.length > i; i++) {
      if (data.checked) {
        inputCollection[i].checked = true;
        valueJson += i + ','

        //valueJson = "1,3,4,5,6,7,8,9,10,11,12,13,14";

      } else {
        valueJson = "";
        inputCollection[i].checked = false;
      }
    }
    valueJson = valueJson.slice(2, -1)
  } else if (data.name == "-1") {
    for (var i = 0; inputCollection.length > i; i++) {
      if (inputCollection[i].name == "1" || inputCollection[i].name == "3" || inputCollection[i].name == "5")
        if (data.checked) {
          inputCollection[i].checked = true;
        } else {
          inputCollection[i].checked = false;
        }
    }
    for (var i = 0; inputCollection.length > i; i++) {
      if (inputCollection[i].checked) {
        if ((inputCollection[i].name != "-1") & (inputCollection[i].name != "0")) {
          if (valueJson == "") {
            valueJson += inputCollection[i].name;
          } else {
            valueJson += "," + inputCollection[i].name;
          }
        }
      }
    }
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = valueJson;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setStartSectionRa(data) {
  let key = "ra" + data.name;
  let keyNumber;
  let thisKEY;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === key) {
      deviceJSON.config[i].subvalues[1].value = data.value + "";
      saveConfig(deviceJSON.config[i]);
    }
  }
  parseAppKey("update_notabs");
}
function setStartSectionRa_281x(data) {
  let sumSec = dataDevice["zr" + data.name + "_0"].value;
  let dataValue = data.value;
  for (var i = Number(data.value) + 1; i < Number(data.value) + Number(sumSec); i++) {
    dataValue += "," + i;
  }

  let key = "zr" + data.name;
  let keyNumber;
  let thisKEY;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === key) {
      deviceJSON.config[i].subvalues[1].value = dataValue + "";
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setStartSectionRk(data) {
  let key = "rk" + data.name;
  let keyNumber;
  let thisKEY;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === key) {
      deviceJSON.config[i].subvalues[0].value = data.value + "";
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setSectionRu(data) {
  let key = "ru" + data.name;
  let keyNumber;
  let thisKEY;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === key) {
      deviceJSON.config[i].subvalues[1].value = data.value + "";
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setStartSectionRb(data) {
  let key = "rb" + data.name;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === key) {
      deviceJSON.config[i].subvalues[1].value = data.value + "";
      saveConfig(deviceJSON.config[i]);
    }
  }
  parseAppKey("update_notabs");
}

function setStartSectionRa_OLD(data) {
  let key = "ra" + data.name;
  let keyNumber;
  let thisKEY;

  let value = parseInt(data.value);
  let rangeUsed = [];
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("ra") != -1) {
      let rsSumm = parseInt(deviceJSON.config[i].subvalues[0].value);
      let rsNumber = parseInt(deviceJSON.config[i].subvalues[1].value);
      if (rsSumm !== 0 && rsNumber !== 0) {
        let data = { start: rsNumber, stop: rsNumber + rsSumm, name: deviceJSON.config[i].key, error: false };
        rangeUsed.push(data);
      }
    }
    if (deviceJSON.config[i].key === key) {
      keyNumber = parseInt(deviceJSON.config[i].subvalues[0].value);
      thisKEY = deviceJSON.config[i];
    }
  }

  let error = false;
  let stopShleif = parseInt(key_RL_MIN) + parseInt(key_RL_MAX) - 1; //Всего шлейфов

  for (var i = 0; i < rangeUsed.length; i++) {
    if (key !== rangeUsed[i].name) {
      if (value >= rangeUsed[i].start && value < rangeUsed[i].stop) {
        rangeUsed[i].error = true;
        error = true;
      } else if (value + keyNumber >= rangeUsed[i].start && value + keyNumber < rangeUsed[i].stop) {
        rangeUsed[i].error = true;
        error = true;
      } else if (stopShleif - value < keyNumber) {
        rangeUsed[i].error = true;
        error = true;
      }
    }
  }
}

function setOC_CONTROL_SECTIONSchange(data, n) {
  // n == ключ oz или oq
  let rowsId =
    data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
  let key = n + rowsId;
  let valueJson = "";
  let sec = data.name;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      valueJson = deviceJSON.config[i].subvalues[0].value;
    }
  }
  let arrValueJson = valueJson.length > 0 ? valueJson.split(",") : [];

  if (data.checked) {
    arrValueJson.push(sec);
  } else {
    for (var i = 0; i < arrValueJson.length; i++) {
      if (arrValueJson[i] == sec) {
        arrValueJson.splice(i, 1);
      }
    }
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = arrValueJson.toString();
      saveConfig(deviceJSON.config[i]);
    }
  }
}


function setOO_CONTROL_SECTIONSchange(data, modal, id) {
  const lock = data.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.childNodes[1].childNodes[0].value
  if (id != "-1") {
    if (modal == true) {
      let rowsId = data.parentElement.className;
      let key = "oq" + rowsId;
      let valueJson = "";
      let sec = data.name;
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          valueJson = deviceJSON.config[i].subvalues[0].value;
        }
      }

      if (data.checked) {
        if (valueJson == "") {
          valueJson = sec;
        } else {
          valueJson += "," + sec;
        }
      } else {
        const newValueJson = valueJson.split(',').filter(val => val != sec).join()
        valueJson = newValueJson
        // valueJson = valueJson.replace("," + sec, "");
        // valueJson = valueJson.replace(sec + ",", "");
        // valueJson = valueJson.replace(sec, "");
      }
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = valueJson;
          saveConfig(deviceJSON.config[i]);
        }
      }
      // parseAppKey("update"); TODO рендер ?
      parseAppKey("update_notabs");
    }
    else {
      let rowsId = data.parentElement.className;
      let key = "oq" + rowsId;
      let valueJson = "";
      let sec = data.name;
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          valueJson = deviceJSON.config[i].subvalues[0].value;
        }
      }

      if (data.checked) {
        if (valueJson == "") {
          valueJson = sec;
        } else {
          valueJson += "," + sec;
        }
      }
      else {
        const newValueJson = valueJson.split(',').filter(val => val != sec).join()
        valueJson = newValueJson
        //старый код
        // valueJson = valueJson.replace("," + sec, "");
        // valueJson = valueJson.replace(sec + ",", "");
        // valueJson = valueJson.replace(sec, "");

        // код для IE6
        // var newValueJson = valueJson.split(',')
        // for (var i = 0; i < newValueJson.length; i++) {
        //   if (newValueJson[i] == sec) {
        //     newValueJson.splice(i, 1)
        //   }
        // }
        // valueJson = newValueJson.join()


      }

      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = valueJson;
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
  }
}

function setOC_CONTROL_KTCchange(data, update) {
  if (update) {
    let rowsId =
      data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
    let key = "or" + rowsId;
    let param = "";
    if (data.checked) {
      param = "1";
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = param;
          saveConfig(deviceJSON.config[i]);
        }
      }
    } else {
      param = "0";
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = param;
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
    //parseAppKey("update"); TODO рендер ?
    parseAppKey("update_notabs");
  } else {
    let rowsId =
      data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
    let key = "or" + rowsId;
    let param = "";
    if (data.checked) {
      param = "1";
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = param;
          saveConfig(deviceJSON.config[i]);
        }
      }
    } else {
      param = "0";
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = param;
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
  }
}

function setOC_CONTROL_DEVICEchange(data) {
  let rowsId =
    data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
  let key = "ob" + rowsId;
  let param = "";
  if (data.checked) {
    param = "1";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    param = "0";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}
function setTA_CONTROL_DEVICEchange(data, index) {
  let rowsId =
    data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
  let key = "ta" + rowsId;
  let flagMask = "0001"
  let newChar = data.checked ? "1" : "0";
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      flagMask = decObj[deviceJSON.config[i].subvalues[1].value]
      let newFlagMask = flagMask.substring(0, index) + newChar + flagMask.substring(index + 1);
      let value = Object.keys(decObj).find(key => decObj[key] === newFlagMask) || "0";
      deviceJSON.config[i].subvalues[1].value = value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}



function setOC_CONTROL_FIREchange(data) {
  let rowsId =
    data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
  let key = "of" + rowsId;
  let param = "";
  if (data.checked) {
    param = "1";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    param = "0";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function setOC_CONTROL_GASchange(data) {
  let rowsId =
    data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
  let key = "og" + rowsId;
  let param = "";
  if (data.checked) {
    param = "1";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    param = "0";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function setOC_CONTROL_WATERchange(data) {
  let rowsId =
    data.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.attributes.name.value;
  let key = "ot" + rowsId;
  let param = "";
  if (data.checked) {
    param = "1";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    param = "0";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function setOC_CONTROL_TYPEchange(data, n) {
  // Изменение типа выхода управления для 2813... n == ключ ос или оо
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param = data.value;
  let key = n + rowsId;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
  // Обработка отображения кнопок сработки при взятии/снятии
  let idAcrivityEvent = "armDisarm_exe_" + rowsId; // ID взятии/снятие
  if (param == "3" || param == "10" || param == "11") {
    document.getElementById(idAcrivityEvent)
      ? (document.getElementById(idAcrivityEvent).style.display = "block")
      : console.log("ВУ не найден");
  } else {
    document.getElementById(idAcrivityEvent)
      ? (document.getElementById(idAcrivityEvent).style.display = "none")
      : console.log("ВУ не найден");
  }
  parseAppKey("update_notabs");
  pk4_init_key();
  pk4_render_rele()
}
//проверка значения "время работы" на соответствие диапазону разрешенных значений
function check_CONTROL_OO(data, update, oo_min, oo_max) {
  let key = "oo" + data.name;
  let old_value;
  if ((data.value < oo_min) & (data.value !== "")) {  //два куска кода, которые работают иногда, лучше, чем один, который работает всегда
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        old_value = deviceJSON.config[i].subvalues[1].value;
      }
    }

    data.value = old_value;
    data.style.color = 'red';
    setTimeout(() => data.style.color = 'black', 1000)
    return
  } else if ((data.value > oo_max) & (data.value !== "")) {
    //два куска кода, которые работают иногда, лучше, чем один, который работает всегда
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        old_value = deviceJSON.config[i].subvalues[1].value;
      }
    }

    data.value = old_value;
    data.style.color = 'red';
    setTimeout(() => data.style.color = 'black', 1000)
    return
  }
  set_CONTROL_OO(data, update);
}

function set_CONTROL_OO(data, update) {
  if (update) {
    let param = data.value.replace(/[^\d]/g, ''); // только цыфры
    let key = "oo" + data.name;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
    //parseAppKey("update"); TODO рендер ?
    parseAppKey("update_notabs");
  } else {
    let param = data.value;
    let key = "oo" + data.name;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
    //parseAppKey("update"); TODO рендер ?
    parseAppKey("update_notabs");
  }
}
function set_CONTROL_OE(data) {

  save_Modal_extenders4(data)

}
function setFN_notofication(data, update) {
  if (update) {
    let param = data.checked ? "1" : "0";
    let key = "nf" + data.name;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
    //parseAppKey("update"); TODO рендер ?
    parseAppKey("update_notabs");
  }
}

function setOO_CONTROL_TYPEchange(data) {
  let rowsId
  // let rowsIdNew = data.parentElement.parentElement.childNodes[0].children[0].value;
  if (data.parentElement.parentElement.childNodes[0].children[0]) {
    rowsId = data.parentElement.parentElement.childNodes[0].children[0].value;//для карточки
  } else {
    rowsId = data.parentElement.parentElement.attributes.name.value // для таблицы
  }

  let param = data.value;
  let key = "oo" + rowsId // data.name;
  let who = '' + data.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.id
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      if (param == 12) {
        save_Modal()
        function save_Modal() {
          // Сохранение РАСШИРИТЕЛЯ РР Юпитер - 3214 RS4 Эксперементально!!!!!
          let collectionRS4 = document.getElementsByClassName("nz_ext4");
          for (let i = 0; i < collectionRS4.length; i++) {
            const id = collectionRS4[i].name
            if (collectionRS4[i].value === collectionRS4[i].defaultValue) {
              for (let z = 0; z < virtualExe.length; z++) {
                if (virtualExe[z].numberExe === collectionRS4[i].defaultValue) {
                  let oldOe = "oe" + virtualExe[z].link
                  let oldOeNumberVal = collectionRS4[i].defaultValue
                  for (n in deviceJSON.config) {
                    if (deviceJSON.config[n].key === oldOe) {
                      let arrOe = deviceJSON.config[n].subvalues[1].value.split(",");
                      for (let y = 0; arrOe.length > y; y++) {
                        if (arrOe[y] === rowsId) { //rowsId) {
                          arrOe.splice(y, 1, '0');
                          deviceJSON.config[n].subvalues[1].value = arrOe.toString();
                          saveConfig(deviceJSON.config[n]);
                          parseAppKey("update_notabs");
                          if (who !== 'tab_exe_list') {
                            renderRS4(id)
                          }


                          spiner_stop();
                          return
                        }
                      }

                    }
                  }

                }
              }
            }


          }

        }
      }

      saveConfig(deviceJSON.config[i]);

    }
  }
  // Обработка отображения кнопок сработки при взятии/снятии
  let idAcrivityEvent = "armDisarm_exe_r_" + rowsId//rowsId; // ID взятии/снятие
  if (param == "3" || param == "11" || param == "10") {
    document.getElementById(idAcrivityEvent)
      ? (document.getElementById(idAcrivityEvent).style.display = "block")
      : console.log("ВУ не найден");
  } else {
    document.getElementById(idAcrivityEvent)
      ? (document.getElementById(idAcrivityEvent).style.display = "none")
      : console.log("ВУ не найден");
  }
  parseAppKey("update_notabs");
}
// для встроенного выхода управления
function setOO_CONTROL_TYPEchangeExe(data) {
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let rows = data.parentElement.parentElement.childNodes[0].childNodes[0].value;
  data.parentElement.parentElement.childNodes[2].disabled = true;

  let param = data.value;
  let key = "oo" + data.name;
  let id = ''
  let who = '' + data.parentNode.parentNode.parentNode.parentNode.parentNode.id
  if (rows === '0' && param !== '12') {
    document.getElementById('modal_integral_save').disabled = 'true'
    //  Выводим ошибку
    let txtError =
      '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_device_error")\' class="w3-button">×</span>';
    txtError += '<b> &#9888; Предупреждение:</b> <ul class="w3-ul">';
    txtError += "<li>" + `Не настроен номер  выхода` + "</li>";
    txtError += "</ul>";
    document.getElementById("modal_device_error").innerHTML = txtError;
    $.show("#modal_device_error"); // отображаем ошибки
    stopModal = true
    spiner_stop();
  } else {
    document.getElementById('modal_integral_save').disabled = ''
  }
  let collectionRSExe = document.getElementsByClassName("nz_extExe");
  id = collectionRSExe.name
  if (key !== 'oo0') {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        if (param == 12) {
          // Сохранение РАСШИРИТЕЛЯ РР Юпитер - 3214 RS4 Эксперементально!!!!!
          for (n in deviceJSON.config) {
            if (deviceJSON.config[n].key === 'oh') {
              let arrExe = deviceJSON.config[n].subvalues[1].value.split(",");
              let newArrExe = arrExe.map(el => el === data.name ? '0' : el)
              deviceJSON.config[n].subvalues[1].value = newArrExe.join(",");
              saveConfig(deviceJSON.config[n]);
              break
            }
          }
        }
        saveConfig(deviceJSON.config[i]);
        parseAppKey("update_notabs");
        if (who === 'modal_r_device_body') {
          if (param == 12) open_modal_thisDeviceExit(id)
        }
        spiner_stop();
      }
    }
  }
  if (param == 12 && key === 'oo0') {
    // Сохранение РАСШИРИТЕЛЯ РР Юпитер - 3214 RS4 Эксперементально!!!!!

    for (n in deviceJSON.config) {
      if (deviceJSON.config[n].key === 'oh') {
        let arrExe = deviceJSON.config[n].subvalues[1].value.split(",");
        let newArrExe = arrExe.map(el => el === data.name ? '0' : el)
        deviceJSON.config[n].subvalues[1].value = newArrExe.join(",");
        saveConfig(deviceJSON.config[n]);
        parseAppKey("update_notabs");
        break
      }
    }
  }

  // Обработка отображения кнопок сработки при взятии/снятии
  let idAcrivityEvent = "armDisarm_exe_r_" + rowsId; // ID взятии/снятие
  if (param == "3" || param == "11" || param == "10") {
    document.getElementById(idAcrivityEvent)
      ? (document.getElementById(idAcrivityEvent).style.display = "block")
      : console.log("ВУ не найден");
  } else {
    document.getElementById(idAcrivityEvent)
      ? (document.getElementById(idAcrivityEvent).style.display = "none")
      : console.log("ВУ не найден");
  }
  parseAppKey("update_notabs");

}

function setOC_CONTROL_DELAYchange(data, n) {
  // n == ключ ос или оо
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param = data.value;
  let key = n + rowsId;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setOI_CONTROL_DELAYchange(data) {
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param;
  if (data.checked) {
    param = "1";
  } else {
    param = "0";
  }

  let key = "oi" + rowsId;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}
function setGS_CONTROLchange_IP(data) {
  let key = "";
  let param;
  if ((/([а-яА-Я])/i).test(data.value)) {

    data.value = data.value.slice(0, -1)
  }
  //проверка на буквенное написание серверов приёма
  if ((/([a-zA-Z])/i).test(data.value)) {
    param = data.value.replace(/\./g, ",");
    if (data.id.indexOf("ip") != -1) {
      key = data.id.slice(3);
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
          deviceJSON.config[i].subvalues[0].value = param;
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
  }
  // если букв нет то проверяем на правльное написание ip (добавляем 0 -ли, что бы понимали старые приборы)
  else {
    param = data.value.replace(/\./g, ",");

    let tmpParam = param.split(',')
    if (tmpParam.length === 4) {
      param = (tmpParam.map(item => item.length < 3 ? item.padStart(3, '0') : item)).join(',')

      if (data.id.indexOf("ip") != -1) {
        key = data.id.slice(3);
        for (i in deviceJSON.config) {
          if (deviceJSON.config[i].key == key) {
            deviceJSON.config[i].subvalues[0].value = param;
            saveConfig(deviceJSON.config[i]);
          }
        }
      }

    }
    // если неправbльный формат ввода ip отправляем на сервер пустую строку, она вернет default 000.000.000.000
    else {
      if (data.id.indexOf("ip") != -1) {
        key = data.id.slice(3);
        for (i in deviceJSON.config) {
          if (deviceJSON.config[i].key == key) {
            deviceJSON.config[i].subvalues[0].value = '';
            saveConfig(deviceJSON.config[i]);
          }
        }
      }

    }
  }


}
function setGS_CONTROLchange(data) {
  let key = "";

  let param;

  if (!(/^[0-9]+$/i).test(data.value)) {
    data.value = ''
  }

  param = data.value.replace(/\./g, ",");

  if (data.id.indexOf("ip") != -1) {
    key = data.id.slice(3);
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    key = data.id.slice(4);
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }



}

function setLC_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setXO_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  if (param < 1) {
    param = data.value = "1";
  } else if (param > 180) {
    param = data.value = "180";
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setRANGE_TEMPERATURA_MINchange(data) {
  let param = "";
  let key = "tc1";
  if (data.value < 0) {
    param = "*" + data.value.replace("-", "");
  } else if (data.value >= 0) {
    param = "!" + data.value;
  } else {
    param = "0";
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setRANGE_TEMPERATURA_MAXchange(data) {
  let param = "";
  let key = "tc1";
  if (data.value < 0) {
    param = "*" + data.value.replace("-", "");
  } else if (data.value >= 0) {
    param = "!" + data.value;
  } else {
    param = "0";
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setOPEN_PERIMETRchange(data) {
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param = "";
  let key = "pz" + rowsId;

  if (data.checked) {
    param = "1";
  } else {
    param = "0";
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setOPEN_DOORSchange(data) {
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param = "";
  let key = "ld" + rowsId;

  if (data.checked) {
    param = "1";
  } else {
    param = "0";
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setPARTITION_SENSORSchange(data) {
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param = data.value;
  let key = "yz" + rowsId;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTYPE_SENSORSchange(data) {
  let rowsId = data.parentElement.parentElement.attributes.name.value;
  let param = data.value;
  let key = "";
  let delayInput = data.parentElement.parentElement.childNodes[2].childNodes[0];

  switch (param) {
    case "1":
      if (delayInput.value === "") {
        delayInput.value = 90;
      }
      if (delayInput.disabled) {
        delayInput.disabled = false;
      }
      break;
    case "2":
      if (delayInput.value !== 0) {
        delayInput.value = "";
      }
      if (!delayInput.disabled) {
        delayInput.disabled = true;
      }
      break;
    case "16":
      if (delayInput.value === "") {
        delayInput.value = 90;
        delayInput.disabled = false;
      }

      break;
    default:
      if (delayInput.value !== 0) {
        delayInput.value = "";
      }
      if (!delayInput.disabled) {
        delayInput.disabled = true;
      }
      break;
  }

  if (data.parentElement.parentElement.classList.contains("thisLr")) {
    key = "lr" + rowsId;
  } else {
    key = "lm" + rowsId;
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      let delaySERVER;
      deviceJSON.config[i].subvalues[0].value = param;
      if (delayInput.value === "") {
        delaySERVER = "0";
      } else {
        delaySERVER = delayInput.value;
      }
      deviceJSON.config[i].subvalues[1].value = delaySERVER;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setDELAY_SECTIONSchange(data, pk4) {
  if (!pk4) {
    let rowsId = data.parentElement.parentElement.attributes.name.value;
    let typeSection = data.parentElement.parentElement.childNodes[1].childNodes[0].value;

    let param = data.value;
    if (param < 1) {
      param = data.value = "1";
    } else if (param > 180) {
      param = data.value = "180";
    }

    let key = "";
    if (param === "0") {
      if (typeSection === "1" || typeSection === "16") {
        data.value = "1";
        param = "1";
      }
    }
    if (data.parentElement.parentElement.classList.contains("thisLr")) {
      key = "lr" + rowsId;
    } else {
      key = "lm" + rowsId;
    }
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    let rowsId = data.parentElement.parentElement.attributes.name.value;
    let typeSection = data.parentElement.parentElement.childNodes[1].childNodes[0].value;

    let param = data.value;
    if (param < 1) {
      param = data.value = "1";
    } else if (param > 180) {
      param = data.value = "180";
    }

    let key = "";
    if (param === "0") {
      if (typeSection === "1" || typeSection === "16") {
        data.value = "1";
        param = "1";
      }
    }
    if (data.parentElement.parentElement.classList.contains("thisLr")) {
      key = "lr" + rowsId;
    } else {
      key = "lm" + rowsId;
    }
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function setTEXT_SIMchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setES_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTP_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  if (param < 0) {
    param = data.value = 0;
  } else if (param > 60) {
    param = data.value = 60;
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setEZ_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTi_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setED_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setEL_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  if (param < 1) {
    param = data.value = 1;
  } else if (param > 999) {
    param = data.value = 999;
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}
function setST_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  if (param < 0) {
    param = data.value = 0;
  } else if (param > 999) {
    param = data.value = 999;
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = String(Number(param));
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setIM_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setRC_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}


function setDP_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "dp") {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setDS_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "ds") {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
      parseAppKey("update_notabs");
    }
  }
}

function setMS_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setIE_CONTROLchange(data) {
  let key = data.name;
  let param = data.value;

  if (param === "0") {
    $.hide("#tab_ethernet_param2");
    $.hide("#tab_ethernet_param3");
    $.hide("#tab_ethernet_param4");
    $.hide("#tab_ethernet_param5");
    $.hide("#tab_ethernet_param6");
  } else if (param === "1") {
    $.show("#tab_ethernet_param2");
    $.show("#tab_ethernet_param3");
    $.show("#tab_ethernet_param4");
    $.hide("#tab_ethernet_param5");
    $.hide("#tab_ethernet_param6");
  } else if (param === "2") {
    $.hide("#tab_ethernet_param2");
    $.hide("#tab_ethernet_param3");
    $.show("#tab_ethernet_param4");
    $.show("#tab_ethernet_param5");
    $.show("#tab_ethernet_param6");
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setRANGE_SOUNDchange(data) {
  let key = data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function RADIO_BUTTON_CM_0(data) {
  let key = "cm";
  let param = data.value;
  let checked = data.checked;

  if (param === "1") {
    let el = document.getElementsByClassName("returnMainSim");
    for (var i = 0; i < el.length; i++) {
      el[i].value = "";
      el[i].disabled = true;
    }
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        deviceJSON.config[i].subvalues[1].value = 1 + "";
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    let el = document.getElementsByClassName("returnMainSim");
    for (var i = 0; i < el.length; i++) {
      el[i].disabled = false;
      el[i].value = "1";
    }
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[0].value = param;
        deviceJSON.config[i].subvalues[1].value = 1 + "";
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

const hexLetter = { '10': 'a', '11': 'b', '12': 'c', '13': 'd', '14': 'e', '15': 'f' }
function hextoString(deviceParam) {
  if (deviceParam > 9) {
    for (const key in hexLetter) {
      if (key === deviceParam) {
        deviceParam = hexLetter[key]
      }
    }
  }
  let hex = deviceParam
  return Array.from(parseInt(hex, 16).toString(2).padStart(4, '0'))
}

function RADIO_BUTTON_FC_0(data) {
  let key = "fc";
  let bit = data.value;
  let checked = data.checked;
  let deviceParam = ''

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceParam = deviceJSON.config[i].subvalues[0].value
    }
  }

  let numberArray = hextoString(deviceParam);

  if (checked) {
    numberArray.splice(bit, 1, '1')
  } else {
    numberArray.splice(bit, 1, '0')
  }
  let hextobin = numberArray.join('')

  let stringToserver = parseInt(hextobin, 2).toString(16)
  if (!Number(stringToserver)) {
    for (const key in hexLetter) {
      if (hexLetter[key] === stringToserver) {
        stringToserver = key
      }
    }
  }


  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = stringToserver;
      saveConfig(deviceJSON.config[i]);
    }

  }

}

function newDataControl(data) { }

function RADIO_BUTTON_AT1(data) {
  let key = "at1";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function RADIO_BUTTON_PR(data) {
  let key = "pr";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function RADIO_BUTTON_SM(data) {
  let key = "sm";
  let param = data.value;

  if (param == 0) {
    $.hide(".gsm_lock_sm");
  } else {
    $.show(".gsm_lock_sm");
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function RADIO_BUTTON_SK(data) {
  let key = "sk";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function RADIO_BUTTON_SG(data) {
  let key = "sg";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}
function swapSectionVersionPO(data) {

  param_zip_number = data.value;
}

function RADIO_BUTTON_MC(data) {
  let key = "mc";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function RADIO_BUTTON_BT(data) {
  let key = "bt";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTEXTchangeCB1_2_PERIOD(data) {
  data.value = data.value.replace(/\D/g, '')
  if (data.value >= 49 || data.value < 0 || !data.value) {
    data.value = 0;
    alertbox.show("Период опроса баланса SIM карты от 1 до 48 часов");
  }

  let numberSim = data.name.slice(2).charAt(0);
  let key = "cb" + numberSim;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTEXTchangeCB1_2_CODE(data) {
  let numberSim = data.name.slice(2).charAt(0);
  let key = "cb" + numberSim;

  if (!data.value) {
    data.value = '0'
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = data.value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setINT_CM_1change(data) {
  data.value = data.value.replace(/\D/g, '')
  if (dataDevice['td'].value[0] && dataDevice['td'].value[0] === 'S') {
    if (data.value > 24) {
      data.value = 24;
      data.style.color = "red";
      setTimeout(() => data.style.color = 'black', 1000)
    } else if ((data.value < 1) & (data.value !== "")) {
      data.value = 1
      data.style.color = "red";
      setTimeout(() => data.style.color = 'black', 1000)
    } else {
      data.style.color = "#000";
    }

    let key = "cm";
    let param = data.value;

    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    if (data.value > 120) {
      data.value = 120;
      data.style.color = "red";
      setTimeout(() => data.style.color = 'black', 1000)
    } else if ((data.value < 1) & (data.value !== "")) {

      data.value = 1;
      data.style.color = "red";
      setTimeout(() => data.style.color = 'black', 1000)
    } else {
      data.style.color = "#000";
    }

    let key = "cm";
    let param = data.value;

    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == key) {
        deviceJSON.config[i].subvalues[1].value = param;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }

}

function setINT_CM_120change(data) {
  if (data.value > 120) {
    data.value = 120;
    data.style.color = "red";
  } else if ((data.value < 1) & (data.value !== "")) {
    data.value = 1;
    data.style.color = "red";
  } else {
    data.style.color = "#000";
  }

  let key = "cm";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}


function setINT_FC_255change(data) {
  if (data.value > 255) {
    data.value = 255;
    data.style.color = "red";
  } else if ((data.value < 0) & (data.value !== "")) {
    data.value = 0;
    data.style.color = "red";
  } else {
    data.style.color = "#000";
  }

  let key = "fc";
  let param = data.value;

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[1].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setOwControl(data) {
  let key = "ow";
  let value = data.value;
  saveSingleKey(key, value);
}

function setOsControl(data) {
  let key = "os";
  let value = data.value;
  saveSingleKey(key, value);
}

function setTEXTchange(data) {
  let value = data.value
  if (data.name === 'mp') {
    value = value.replace(/:/g, '')
    const valid = value.split('').filter((el) => !(/^[a-fA-F0-9-]+$/).test(el))
    if (valid.length !== 0) {
      document.getElementById('danger_name').innerText = `Параметр Wi-Fi: MAC(AP)`

      if (valid.length === 1) {
        document.getElementById('danger').innerText = `Введен недопустимый символ: ${valid.join(',')}`
      } else {
        document.getElementById('danger').innerText = `Введены недопустимые символы: ${valid.join(',')}`
      }
      document.getElementById('modal-error').style.display = 'flex'
      buttonSaveDeviceDisabled()
      return null
      //value = '000000000000'
    } else {
      if (value.length > 12) {
        document.getElementById('danger_name').innerText = `Параметр Wi-Fi: MAC(AP)`
        document.getElementById('danger').innerText = 'Превышена допустимая длина'
        document.getElementById('modal-error').style.display = 'flex'
        value = value.slice(0, 12)
        buttonSaveDeviceDisabled()
        return null
      } else {
        document.getElementById('modal-error').style.display = 'none'
        let count = ''
        for (let i = 0; i < 12 - value.length; i++) {
          count += '0'
        }
        value += count
      }
    }
  }
  if (data.name === '!!') {
    if (data.value.match(/[^0-9]/g)) {
      data.value = data.value.slice(0, -1);
      return;
    }
    if (data.value.length > 5) {
      data.value = data.value.slice(0, -(data.value.length - 5));
      return;
    }

  }
  if (data.name === 'km' || data.name === 'kr') {
    data.value = data.value.replace(/[^\d]/g, '');
  }
  saveSingleKey(data.name, value)
}
function checkBinInput(str, name) {
  const text = name === 'wk' ? 'Пароль шифрования' : 'SSID-WiFi сети'
  for (let i = 0; i < str.length; i++) {
    if (str[i].charCodeAt(0) > 0x1F && str[i].charCodeAt(0) < 0x7F && str[i].charCodeAt(0) !== 0x22) {
      if (str[i].charCodeAt(0) === 0x5C) {
        if (str.length - i < 4) {
          document.getElementById('danger_name').innerText = `Параметр Wi-Fi: ${text}`
          document.getElementById('danger').innerText = `нехватает символов после \\`
          document.getElementById('modal-error').style.display = 'flex'
          buttonSaveDeviceDisabled()
          return null // нехватает символов после слеш
        }
        if (str[i + 1] !== 'x') {
          document.getElementById('danger_name').innerText = `Параметр Wi-Fi: ${text}`
          document.getElementById('danger').innerText = `после \\ должен быть x`
          document.getElementById('modal-error').style.display = 'flex'
          buttonSaveDeviceDisabled()
          return null // после слеша должен быть x
        }
        const hex = str.substring(i + 2, i + 4)
        const valid = hex.split('').filter((el) => !(/^[a-fA-F0-9-]+$/).test(el))
        if (valid.length !== 0) {
          document.getElementById('danger_name').innerText = `Параметр Wi-Fi: ${text}`
          document.getElementById('danger').innerText = `после \\x должно быть два символа от 0-9 или A-F`
          document.getElementById('modal-error').style.display = 'flex'
          buttonSaveDeviceDisabled()
          return null // после \x должно быть два символа от 0-9 или A-F
        }
        i += 3
      }

    } else {

      document.getElementById('danger_name').innerText = `Параметр Wi-Fi: ${text}`
      document.getElementById('danger').innerText = `Недопустимый символ: ${str[i]}`
      document.getElementById('modal-error').style.display = 'flex'
      buttonSaveDeviceDisabled()
      return null //недопустимый символ
    }
  }
  document.getElementById('modal-error').style.display = 'none'
  return str // успех
}


function decodeUserToDevice(value, name) {
  let newCode = encodeURI(value)
  newCode = newCode.replace(/%/g, '\\x')
  let acc = ''
  let count = 0
  for (let i = 0; i < newCode.length; i++) {
    if (newCode[i] === '\\' && newCode[i + 1] === 'x') {
      let val = parseInt(newCode[i + 2] + newCode[i + 3], 16)

      if (val > 0x1F && val < 0x7F && val !== 0x22 && val !== 0x5C) {
        acc += String.fromCharCode(val)
      }
      else {
        acc += newCode.substring(i, i + 4)
      }
      i += 3
    }
    else {
      acc += newCode[i]
    }
    count++
  }
  if (count <= 32) {
    document.getElementById('modal-error').style.display = 'none'
    return acc
  } else {
    const text = name === 'wk' ? 'Пароль шифрования' : 'SSID-WiFi сети'
    document.getElementById('danger_name').innerText = `Параметр Wi-Fi: ${text}`
    buttonSaveDeviceDisabled()
    document.getElementById('danger').innerText = 'Превышена допустимая длина'
    document.getElementById('modal-error').style.display = 'flex'

    return null
  }
}
function buttonSaveDeviceDisabled() {

  if (document.getElementById('buttonSaveDevice').style.display !== 'none') {
    document.getElementById("buttonSaveDevice").classList.remove("w3-green");
    document.getElementById("buttonSaveDevice").classList.remove("w3-vibration");
    document.getElementById("buttonSaveDevice").classList.remove("w3-border-green")
    document.getElementById("buttonSaveDevice").classList.remove("w3-border-white")
    document.getElementById("buttonSaveDevice").classList += " w3-border-green w3-green w3-vibration";
    document.getElementById("buttonSaveDevice").style.display = 'block'
    document.getElementById("buttonSaveDevice").disabled = true
  }

}


function setTEXTchangeUnicode(data) {
  if (!binFlag) {
    const value = decodeUserToDevice(data.value, data.name)
    if (value === null) {
      data.value = data.value.slice(0, data.value.length - 1)
      return
    }
    if (data.name === 'ws') {
      saveSingleKey(data.name, value)
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == "mp") {
          if (deviceJSON.config[i].subvalues[0].value !== '000000000000' && handleClickNetwork) {
            handleClickNetwork = false
            deviceJSON.config[i].subvalues[0].value = '000000000000'
            saveConfig(deviceJSON.config[i]);
            errorModal(`Cброс MAC(AP)`)
            parseAppKey("update_notabs");
          }
        }
      }
    }
    else {
      saveSingleKey(data.name, value)
    }
  } else {
    valueBin = checkBinInput(data.value, data.name)
    if (data.name === 'ws') {
      saveSingleKey(data.name, valueBin)
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == "mp") {
          if (deviceJSON.config[i].subvalues[0].value !== '000000000000' && handleClickNetwork) {
            handleClickNetwork = false
            deviceJSON.config[i].subvalues[0].value = '000000000000'
            saveConfig(deviceJSON.config[i]);
            errorModal(`Cброс MAC(AP)`)
            parseAppKey("update_notabs");
          } else {
            if (valueBin === null) return
          }
        }
      }
    } else {
      saveSingleKey(data.name, valueBin)
    }
  }

}

function errorModal(text) {
  document.getElementById('modal-error').style.display = 'flex'
  document.getElementById('danger_name').innerText = ``
  document.getElementById('danger').innerText = text
  setTimeout(() => {
    document.getElementById('modal-error').style.display = 'none'
  }, 1000)
}


function lazySaveServer(name, value) {
  clearTimeout(timer)
  timer = setTimeout(() => {
    saveSingleKey(name, value)
  }, 500);
}


function setTEXTchange_SIMlow(data) {
  if (data.value > 65535) {
    data.value = 65535
  }
  if (data.value < 1) {
    data.value = 0
  }
  if (Number.isNaN(+data.value)) {
    data.value = 0
  }
  saveSingleKey(data.name, data.value);
}

function setTEXT_NAME_DEVICEchange(data) {
  data.value = data.value.trim();
  data.value = data.value.replace(/\s+/g, '');
  data.value = data.value.substring(0, 10);
  saveSingleKey(data.name, data.value);
}

function setTEXTchange_GI_decimal(data) {
  const hexInput = document.getElementById('hexInput');
  const decInput = document.getElementById('decInput');
  decInput.addEventListener('input', updateValue)
  function updateValue(e) {
    let tmp = ''
    let checkReg = (e.target.value).match(/[\0-9\s]/g)
    if (checkReg) {
      checkReg = checkReg.join('');
      tmp = (checkReg).replace(/[\-\s]/g, "")
      if (Number(tmp) > 281474976710655) {
        tmp = checkReg.slice(0, -1)
        data.value = tmp
      }
      else {
        data.value = checkReg
      }
    } else {
      data.value = ''
    }
    hexInput.value = ''
    if (tmp.length !== 0) {
      let hex = parseInt(tmp, 10).toString(16).padStart(12, '0').toUpperCase()
      hexInput.value = `${hex.substr(0, 4)}-${hex.substr(4, 4)}-${hex.substr(8, 4)}`

    }
  }

}

function setTEXTchange_GI_decimal_unfocus(data) {
  let num = (data.value).replace(/[\-\s]/g, "")
  let hex = parseInt(num, 10).toString(16).padStart(12, '0').toUpperCase()
  count = 0
  let newNum = ''
  for (let i = num.length - 1; i >= 0; i--) {
    newNum = num[i] + newNum
    count++
    if (count === 3 && i !== 0) {
      newNum = ' ' + newNum
      count = 0
    }
  }
  data.value = newNum
  saveSingleKey(data.name, hex);
}

function setTEXTchange_GI(data) {
  const hexInput = document.getElementById('hexInput');
  const decInput = document.getElementById('decInput');
  hexInput.addEventListener('input', updateValue);

  function updateValue(e) {
    let tmp = ''
    let checkReg = (e.target.value).match(/[\A-f0-9\-]/g)
    if (checkReg) {
      data.value = checkReg.join('').toUpperCase();
    } else {
      data.value = '';
    }
    tmp = (data.value).replace(/[\-\s]/g, "")

    if (tmp.length > 12) {
      tmp = tmp.slice(0, -1)
      data.value = data.value.slice(0, -1).toUpperCase()
    }
    decInput.value = ''
    if (tmp) {
      let num = parseInt(tmp, 16).toString(10)
      let newNum = ''
      let count = 0
      for (let i = num.length - 1; i >= 0; i--) {
        newNum = num[i] + newNum
        count++
        if (count === 3 && i !== 0) {
          newNum = ' ' + newNum
          count = 0
        }
      }
      decInput.value = newNum
    }
  }

}
function setTEXTchange_GK(data) {
  const hexInput = document.getElementById(data.id);

  hexInput.addEventListener('input', updateValue);

  function updateValue(e) {
    let tmp = ''
    let checkReg = (e.target.value).match(/[\A-f0-9\-]/g)
    if (checkReg) {
      data.value = checkReg.join('').toUpperCase();
    } else {
      data.value = '';
    }
    tmp = (data.value).replace(/[\-\s]/g, "")

    if (tmp.length > 16) {
      tmp = tmp.slice(0, -1)
      data.value = data.value.slice(0, -1).toUpperCase()
    }
    hexInput.value = data.value
  }

}

function setTEXTchange_GI_unfocus(data) {
  let identDev = data.value.replace(/[\-\s]/g, "").padStart(12, '0').toUpperCase()
  let ururu = ''
  if (identDev.length !== 0) {
    ururu = `${identDev.substr(0, 4)}-${identDev.substr(4, 4)}-${identDev.substr(8, 4)}`
    data.value = ururu
  }
  saveSingleKey(data.name, identDev);
}

function setTEXT_PH15change(data) {
  let val = "";
  val = data.value;
  //проверка не требуется, код в приборах изменен.
  /*   if (data.value.length != 15) {
      for (var i = data.value.length; i < 15; i++) {
        val += "%20";
      }
    } */
  saveSingleKey(data.name, val);
}

function setTEXTchange_CA(data) {
  if (data.value > 20) {
    data.value = 20;
  }

  if (data.value < 1) {
    data.value = 1;
  }

  saveSingleKey(data.name, data.value);
}

function setTEXTchange_gd0(data) {
  if (Number(data.value) > 900) {
    data.value = '900'
  }
  if (!Number(data.value)) {
    data.value = '0'
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "gd") {
      deviceJSON.config[i].subvalues[0].value = data.value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}
function debounce(fn, ms) {
  let timeout;
  return function (...args) {
    const fnCall = () => { fn.apply(this, args) }
    clearTimeout(timeout)
    timeout = setTimeout(fnCall, ms)
  }
}
setTEXTchangeDebounce = debounce(setTEXTchange_gd1, 1500)

function setTEXTchange_gd1(data) {
  if (Number(data.value) > 1800) {
    data.value = '1800'
  }
  if (Number(data.value) < 10) {
    data.value = '10'
  }

  if (!Number(data.value)) {
    data.value = '10'
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "gd") {
      deviceJSON.config[i].subvalues[1].value = data.value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTEXTchange_gt0(data) {
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "gt") {
      deviceJSON.config[i].subvalues[0].value = data.value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTEXTchange_gt1(data) {
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "gt") {
      deviceJSON.config[i].subvalues[1].value = data.value;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function setTEXTchangeDNS(data) {
  let dns = data.value.replace(/\./g, ",");
  saveSingleKey(data.name, dns);
}

function setTEXTchangeOnlyNumber(data) {
  if (data.value.match(/[^0-9]/g)) {
    data.value = data.value.slice(0, -1);
    return;
  }
  if (data.value.length >= 9) {
    data.value = data.value.slice(0, -(data.value.length - 8));
    return;
  }

  saveSingleKey(data.name, data.value);
}


function noProgrammableInput(data) {
  binFlag = data.checked
  localStorage.setItem('binFlag', binFlag)
  parseAppKey("update_notabs");
}
function genAutoIP(data) {
  autoIP = data.checked
  localStorage.setItem('autoIP', autoIP)
  if (autoIP) {
    saveSingleKey('ip1', '000,000,000,000');
    saveSingleKey('ip2', '000,000,000,000');
    saveSingleKey('ip3', '000,000,000,000');
  }

  parseAppKey("update_notabs");
}
function genAutoDNS(data) {
  autoDNS = data.checked
  localStorage.setItem('autoDNS', autoDNS)
  if (autoDNS) {
    saveSingleKey('ip4', '000,000,000,000');
  }
  parseAppKey("update_notabs");
}



function setTEXTchange_OS(data) {
  if (data.value.match(/[^a-fA-F0-9]/g) || data.value.length > 16) {
    data.value = data.value.slice(0, -1);
    return;
  }
  saveSingleKey(data.name, data.value);
}

function setTEXTchange_IP(data) {
  let param = data.value.replace(/\./g, ",");
  saveSingleKey(data.name, param);
}

function setINTchange(data) {
  saveSingleKey(data.name, data.value);
}

function setIP_ADDRchange(data) {
  let value = data.value.replace(/\./g, ",");
  saveSingleKey(data.name, value);
}

function setBOOLEANchange(data) {
  let value = "";
  if (data.checked) {
    value = 0;
  } else {
    value = 1;
  }
  saveSingleKey(data.name, value);
}

function setBOOLEANchange_zapret(data) {
  let value = "";
  if (data.checked) {
    value = 1;
  } else {
    value = 0;
  }
  saveSingleKey(data.name, value);
}
function setBOOLEANchange_bluetooth(data) {
  let value = "";
  if (data.checked) {
    value = 1;
  } else {
    value = 0;
  }
  saveSingleKey(data.name, value);
}

function setBOOLEANchange_vzlom(data) {
  let value = "";
  if (data.checked) {
    value = 1;
  } else {
    value = 0;
  }
  saveSingleKey(data.name, value);
}

function setBOOLEANchange_ha(data) {
  let value = "";
  if (data.checked) {
    value = 1;
  } else {
    value = 0;
  }
  saveSingleKey(data.name, value);
}

function setBOOLEANchange_br(data) {
  let value = "";
  if (data.checked) {
    value = 1;
  } else {
    value = 0;
  }
  saveSingleKey(data.name, value);
}

function setBOOLEANchange_tb(data) {
  let value = "";
  if (data.checked) {
    value = 1;
  } else {
    value = 0;
  }
  saveSingleKey(data.name, value);
}

function saveSingleKey(key, param) {
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[0].value = param + "";
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function saveDoubleKey(key, param1, param2) { }

function saveConfig(data) {
  if (DEVICEINFO[DEVICEMODEL]) {
    if (DEVICEINFO[DEVICEMODEL].defaultClick == "defaultClick" || TUNER_DEVICE_ID !== "-1") {

      document.getElementById("buttonSaveDevice").classList.remove("w3-green");
      document.getElementById("buttonSaveDevice").classList.remove("w3-vibration");
      document.getElementById("buttonSaveDevice").classList.remove("w3-border-green")
      document.getElementById("buttonSaveDevice").classList.remove("w3-border-white")
      document.getElementById("buttonSaveDevice").classList += " w3-border-green w3-green w3-vibration";
      document.getElementById("buttonSaveDevice").style.display = 'block'
      document.getElementById("buttonSaveDevice").disabled = ''
    }
  }
  let repeat = false;
  let repeatId = "";
  if (KEYFORSAVE.length > 0) {
    for (var i = 0; KEYFORSAVE.length > i; ++i) {
      if (data.key == KEYFORSAVE[i].key) {
        repeat = true;
        repeatId = i;
      }
    }
  } else {
    repeat = false;
  }

  if (repeat) {
    KEYFORSAVE.splice(repeatId, 1);
    KEYFORSAVE.push(data);
  } else {
    KEYFORSAVE.push(data);
  }
  liveSaveInterface();
  console.log("Сохранение на сервер  ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓");
  console.log(KEYFORSAVE);
}
function saveConfigAll(data) {
  document.getElementById("buttonSaveDevice").classList.remove("w3-green");
  document.getElementById("buttonSaveDevice").classList.remove("w3-vibration");
  document.getElementById("buttonSaveDevice").classList.remove("w3-border-green")
  document.getElementById("buttonSaveDevice").classList.remove("w3-border-white")
  document.getElementById("buttonSaveDevice").classList += " w3-border-green w3-green w3-vibration";
  document.getElementById("buttonSaveDevice").style.display = 'block'
  document.getElementById("buttonSaveDevice").disabled = ''
  let repeat = false;
  let repeatId = "";
  if (KEYFORSAVE.length > 0) {
    for (var i = 0; KEYFORSAVE.length > i; ++i) {
      if (data.key == KEYFORSAVE[i].key) {
        repeat = true;
        repeatId = i;
      }
    }
  } else {
    repeat = false;
  }

  if (repeat) {
    KEYFORSAVE.splice(repeatId, 1);
    KEYFORSAVE.push(data);
  } else {
    KEYFORSAVE.push(data);
  }

  console.log("Сохранение на сервер  ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓ ↓");
  console.log(KEYFORSAVE);
}


function setSerialXxad(data) {
  let key = "xxad" + data.name;
  let param = data.value;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == key) {
      deviceJSON.config[i].subvalues[2].value = param;
      saveConfig(deviceJSON.config[i]);
    }
  }
}

function swapOmlocked(data) {
  if (data.checked) {
    document.getElementById("swapOmlock").disabled = false;
    document.getElementById("swapOmlock").value = 24;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == "om") {
        deviceJSON.config[i].subvalues[0].value = "24";
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    document.getElementById("swapOmlock").disabled = true;
    document.getElementById("swapOmlock").value = "";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == "om") {
        deviceJSON.config[i].subvalues[0].value = "0";
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}
function swapOnlocked(data) {
  if (data.checked) {
    document.getElementById("swapOnlock").disabled = false;
    document.getElementById("swapOnlock").value = 24;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == "on") {
        deviceJSON.config[i].subvalues[0].value = "24";
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else {
    document.getElementById("swapOnlock").disabled = true;
    document.getElementById("swapOnlock").value = "";
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == "on") {
        deviceJSON.config[i].subvalues[0].value = "0";
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}
function alarmModeSwitch(data) {
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "en") {
      if (data.checked) {
        deviceJSON.config[i].subvalues[0].value = "0";
      } else {
        deviceJSON.config[i].subvalues[0].value = "1";
      }
      saveConfig(deviceJSON.config[i]);
    }
  }

}
/*   //Переводим bin в hex
  const bin = sectionsArr.join('')
  const objvalue = Object.values(hexObj)
  const objkey = Object.keys(hexObj)
  const binArr = []
  for (let i = 0; i < bin.length / 4; i++) {
    offset = (((i + 1) % 2) + (i & 0xFFFFFFFE)) * 4
    binSub = bin.substring(offset, offset + 4)
    binArr.push(binSub)

  }
  for (let i = 0; i < binArr.length; i++) {
    for (let j = 0; j < objvalue.length; j++) {
      if (binArr[i] === objvalue[j]) {
        bintohex += objkey[j]
      }

    }

  } */