let VERSION_TUNER = "5.2.71";
let vhost = "tuning"; // url для запросов fetch
let DEVICEMODEL = ""; // модель прибора
let stateDevice = 1; //начальный статус загрузки
let rkps_device = {};

// let TUNER_DEVICE_ID = '-1';
let listControls = {}; // сгенерированные контролы
let parseJsonKey = {}; // распарсенные ключи с прибора
let dataDevice = {}; // ключи которые требуют парсинга
let appKey = {}; //ключи для внутреннего пользования
let dataForSetConfig = []; // данные для отправки еа прибор
let selectComPort; //выбранный COM-порт для подключения к прибору
let KEY_DESCRIPTION = {}; //Справочник по ключам
let RS485 = {}; //Справочник по расширителям
let portWebsocket = "";
let dataNewKeyUz = ""; // временное хранилище ключей UZ для редактирования
let strNewKeyBlockSections = ""; //временное хранилище привязки разделов к ключам
let KEYFORSAVE = []; // массив для сохранения конфигурации на Сервер
let deviceJSON = {};
let gm_locked = { gm1: false, gm2: false };
let ACTIVE_TABS = "default"; // текущая открытая вкладка
let HEIGHT_RKPS = 300; // текущая открытая вкладка
let fileXCPU;
let fileZIP;
let arrayZfile = [];
let arrayZfileSecCore = [];
let elesta4Exe = null;
let param_zip_number = null;
let fileMODEM;
let keyForDelete = []; // Ключи которые требуетсчя сбросить на дефолтные значения
let fileBlob = null
let fileSecCore = null
let crc = null
let crc_SecCore = null
let vc = ''
let hs = ''
let td = ''
let folderPath = ''
let updateFileName = ''
let numberUpdateFunc = 0
let isSecondCore = false
let paramsReleBrTb = true
//let MODE_CONFIGURATOR = null; // режим работы конфигуратора
let MODE_CONFIGURATOR = "developer"; // режим работы конфигуратора
let initSearchRadio = false; // режим поиска РК датчика
let ERROR_DSC_XXCC = "Конфигурация не сохранена, выберите каналы трансивера и повторите попытку";
let ERROR_NEW_DEVICE_DSC_XXCC = "Добавление устройства невозможно, выберите каналы трансивера и повторите попытку";
let USB_FOR_READ = ""; // USB для записи на носитель
let VIEW_TLMTR_RKPS = "table"; // отображение телеметрии РКПС
let CACHE_EDIT_INTEGRATION_ZONE; // открытая дляредактирования встроенная зона
const saturnDevice = ['S2414', 'S2813', 'S2814', 'S2818', 'S2819',]
const deviceSecondCore = ['S2414', 'S2813', 'S2814', 'S2818', 'S2819', 'J2444', 'J2444_GD', 'J2444E', 'J2444_2022', 'J2463', 'J2463E', 'J2463_GD', 'J2463_2022']
//==============================КОМАНДЫ GET-ЗАПРОСОВ===============================
let Q_CMD = "/device?id=" + TUNER_DEVICE_ID + "&cmd=";
let CMD_NEW_BLOCK = Q_CMD + "1", // Создание блока параметров нового прибора
  CMD_FILE_SAVE = Q_CMD + "2", // Сохранение конфигурационного файла
  CMD_FILE_READ = Q_CMD + "4", // Чтение конфигурационного файла
  CMD_DEVICE_CONNECT = Q_CMD + "11&com=", // Подключение к прибору по com порту
  CMD_DEVICE_DISCONNECT = Q_CMD + "11", // Отключение к прибору по com порту
  CMD_DEVICE_AUTH = Q_CMD + "12&pass=", // Авторизация
  CMD_KEY_LEARN = Q_CMD + "13", // ВКЛючение обучения ключам
  CMD_KEY_UNLEARN = Q_CMD + "14", // ВЫКЛючение обучения ключам
  CMD_DEVICE_RESET = Q_CMD + "21", // Перезапуск прибора
  CMD_CONF_DEFAULT = Q_CMD + "22", // Сброс настроек на заводские
  CMD_IP_UNLOCK = Q_CMD + "23", // Снятие блокировки настройки серверов
  CMD_CONF_WRITE = Q_CMD + "31", // Запись конфигурационных данных
  CMD_CONF_READ = Q_CMD + "32", // Запрос конфигурации с прибора
  CMD_RS_SPEED = Q_CMD + "41&", // Установка скорости RS-485
  CMD_RS_ADD = Q_CMD + "42", // Добавить новый расширитель
  CMD_RS_REMOVE = Q_CMD + "43", // Удаление расширителей
  CMD_RS_REPLACE = Q_CMD + "44", // Заменить расширитель
  CMD_OK_ON = Q_CMD + "51", // Включить ОК
  CMD_OK_OFF = Q_CMD + "52", // Выключить OK
  CMD_ZONE_CALIBRATION = Q_CMD + "61", // Калибровка зоны
  CMD_ZONE_RESET = Q_CMD + "62", // Сброс зоны
  CMD_SOFT_UPDATE = Q_CMD + "71", // Начать обновление прошивки прибора
  CMD_SOFT_UPDATE2 = Q_CMD + "73", // Начать обновление прошивки прибора
  CMD_LOG_LOAD = Q_CMD + "81", // Начать загрузку логов
  CMD_LOG_STOP = Q_CMD + "82", // Остановить загрузку логов
  CMD_LOG_CLEAR = Q_CMD + "83", // Очистить логи в приборе
  CMD_EVENTS_LOAD = Q_CMD + "91", // Начать загрузку событий
  CMD_SEND_DEVICE = Q_CMD + "100&text=", // Отправить произвольную команду на прибор
  CMD_BURN_MAIN_CORE = Q_CMD + "71",
  CMD_SEARCH_RADIO = Q_CMD + "45&radio=", // Начать поиск радиоустрйоств
  CMD_STOP_SEARCH_RADIO = Q_CMD + "46"; // Остановить поиск радиоустрйоств
//=================================================================================

//Список приборов и их идентификаторы (ключи VC:TD)
const deviceIdentifiers = {
  '0': 'J2443',
  '1': 'J2413',
  '2': 'J2443',
  '3': 'J2463',
  '4': 'J2413',
  '5': 'J2444',
  '6': 'J2403',
  '7': 'J2445',
  '8': 'J2463E',
  '9': 'J2444E',
  '10': 'J1429',
  '11': 'J1429v3',
  '12': 'J2413_GD',
  '13': 'J2443_GD',
  '14': 'J2463_GD',
  '15': 'J2444_GD',
  '16': 'J2445_GD',
  '19': 'J2320',
  '17': 'J2420',
  '21': 'J2421',
  '25': 'J2422',
  '27': 'J2424',
  '28': 'J2425',
  '18': 'J2426',
  '22': 'J2427',
  '23': 'J2428',
  '29': 'J2429',
  '40': 'S2413',
  '26': 'J2321',
  '20': 'J2326',
  '49': 'J2420_v2',
  '50': 'J2421_v2',
  '51': 'J2422_v2',
  '53': 'J2424_v2',
  '54': 'J2425_v2',
  '55': 'J2426_v2',
  '56': 'J2427_v2',
  '57': 'J2428_v2',
  '58': 'J2429_v2',
  '70': 'S2813',
  '71': 'S2814',
  '74': 'S2818',
  '75': 'S2819',
  '84': 'J1431',
  '85': 'J1831',
  '86': 'J1931',
  '87': 'J1433',
  '88': 'J1833',
  '89': 'J1933',
  '90': 'J1439',
  '91': 'J1839',
  '92': 'J1939',
  '93': 'J1443',
  '94': 'J1843',
  '95': 'J1943',
  '128': 'J6423',
  '129': 'J6422',
  '140': 'J3431',
  '141': 'J3438',
  '142': 'J3439',
  '145': 'J2413_2022',
  '146': 'J2443_2022',
  '147': 'J2463_2022',
  '148': 'J2444_2022',
  '149': 'J2445_2022',
  '160': 'J1431_GD',
  '161': 'J1831_GD',
  '162': 'J1931_GD',
  '163': 'J1433_GD',
  '164': 'J1833_GD',
  '165': 'J1933_GD',
  '166': 'J1943_GD',
  '167': 'J1431_GD',
  '168': "J1831_GD",
  '169': "J1931_GD",
  '170': "J1433_GD",
  '171': "J1833_GD",
  '172': "J1933_GD",
  '173': "J1943_GD",

}

//Таблица соответствий прошивки прибора
const tablePatchForUpdate = {
  'J2420': 'jupiter-2420/',
  'J6422': 'jupiter-2420/',
  'J6423': 'jupiter-2420/',
  'J2021': 'pkr-2021/',
  'J2028': 'pkr-2028/',
  'J2029': 'pkr-2029/',
  'J2082': 'pkr-2082/',
  'J2084': 'pkr-2084/',
  'J1431': 'ppkop-1431/',
  'J1433': 'ppkop-1433/',
  'J1831': 'ppkop-1831/',
  'J1833': 'ppkop-1833/',
  'J1931': 'ppkop-1931/',
  'J1933': 'ppkop-1933/',
  'J1943': 'ppkop-1943/',
  'S2413': 'saturn-2413/',
  'S2420': 'saturn-2420/',
  'S2813': 'saturn-2813/',
  'S2814': 'saturn-2814/',
  'S2818': 'saturn-2818/',
  'S2819': 'saturn-2819/',
  'J2403': 'uoo-2403/',
  'J2413': 'uoo-2413/',
  'J2434': 'uoo-2434/',
  'J2443': 'uoo-2443/',
  'J2444': 'uoo-2444/',
  'J2444_1': 'uoo-2444_1/',
  'J2445': 'uoo-2445/',
  'J2463': 'uoo-2463/',
  'J2463_1': 'uoo-2463_1/',
}
//Типы расширителей
const expanderType = {
  '5_0': 'Охранная',
  '5_4': 'Охранная с задержкой (вход/выход)',
  '5_2': 'Охранная с зад. на выход (Проходная)',
  '5_0D': 'Охранная с фикс. зад.(вход/выход)',
  '5_8': 'Охранная с контр. взлома',
  '5_10': 'Охранная с зад.на вых.(Проход.) с контр. взл.',
  '5_1': 'Тревожная (КТС)',
  '5_32': 'ПАТРУЛЬ',
  '4_2': 'ПОЖАРНАЯ',
  '2_2': 'ГАЗ',
  '2_5': 'ВОДА',
  '3_0': 'УПРАВЛЕНИЕ',
  '2_8': 'ПОЛЬЗОВАТЕЛЬСКАЯ',
}
const hexObj = {
  '0': '0000',
  '1': '1000',
  '2': '0100',
  '3': '1100',
  '4': '0010',
  '5': '1010',
  '6': '0110',
  '7': '1110',
  '8': '0001',
  '9': '1001',
  'A': '0101',
  'B': '1101',
  'C': '0011',
  'D': '1011',
  'E': '0111',
  'F': '1111',
}
const decObj = {
  '0': '0000',
  '1': '0001',
  '2': '0010',
  '3': '0011',
  '4': '0100',
  '5': '0101',
  '6': '0110',
  '7': '0111',
  '8': '1000',
  '9': '1001',
  '10': '1010',
  '11': '1011',
  '12': '1100',
  '13': '1101',
  '14': '1110',
  '15': '1111',
}

//Входное напряжение
const powerExt = {
  'high': 'Высокое',
  'low': 'Низкое',
  'norma': 'Норма',
  '': 'Отсутствует',
}
//
// let objName = {
//   ca: { title: "Число неудачных попыток связи перед подключением", description: "1234" },
//   gi: { title: "Идентификатор устройства" }
// }; Привести KEYFORSAVE к такому виду

let HELP = {
  LC: {
    help:
      "Число повторов тревожных сообщений (по охранным шлейфам), после которого происходит блокировка шлейфа в тревожном состоянии. Шлейф разблокируется после выполнения операции постановки или снятия с охраны раздела в который шлейф входит.",
  },
};

KEY_DESCRIPTION["xxfa"] = {
  title: "Отключение проверки радиодатчиков (Экспериментально)",
};
KEY_DESCRIPTION["ms"] = {
  title: "Номер основной SIM-карты",
};
KEY_DESCRIPTION["ii"] = {
  title: "IMEI GSM модема",
};
KEY_DESCRIPTION["oa"] = {
  title: "Псевдоним прибора",
};

KEY_DESCRIPTION["ks1"] = {
  title: "Ключ шифрования файла",
  description:
    "Ключ шифрования, используемый прибором для ограничения доступа к файлу конфигурации. Представляет собой последовательность от 1-ого до 32-х любых символов. Запрашивается при открытии CRY-файла конфигуратором.",
};
KEY_DESCRIPTION["ip1"] = {
  title: "IP-адрес",
};
KEY_DESCRIPTION["em"] = {
  title: "Формирование сообщение «Вход» при нарушении ШС",
};
KEY_DESCRIPTION["dp_0"] = {
  title: "Протокол для соединения",
};
KEY_DESCRIPTION["gd_0"] = {
  title: "Тип 1",
};
KEY_DESCRIPTION["gt_0"] = {
  title: "Ожидание ответа на переданное сообщение",
};
KEY_DESCRIPTION["gt_1"] = {
  title: "Максимальное число неответов на сообщение",
};
KEY_DESCRIPTION["gd_1"] = {
  title: "Тип 2",
};
KEY_DESCRIPTION["ds"] = {
  title: "Способ передачи тревожных сообщений",
};
KEY_DESCRIPTION["br"] = {
  title: "Активация реле при нарушении шлейфа КТС",
};
KEY_DESCRIPTION["tb"] = {
  title: "Активация реле при нарушении тампера",
};
KEY_DESCRIPTION["xo"] = {
  title: "Задержка на выход",
};
KEY_DESCRIPTION["ip2"] = {
  title: "Шлюз сети",
};
KEY_DESCRIPTION["ip3"] = {
  title: "Маска подсети",
};
KEY_DESCRIPTION["ip4"] = {
  title: "Использовать DNS-сервер",
};
KEY_DESCRIPTION["ws"] = {
  title: "SSID Wi-Fi сети",
};
KEY_DESCRIPTION["mp"] = {
  title: "MAC(AP)",
};
KEY_DESCRIPTION["al"] = {
  title: "Уровень чувствительности датчика движения",
};
KEY_DESCRIPTION["rc"] = {
  title: "Разрешение изменения настроек/управления прибором через СМС-сообщения",
};
KEY_DESCRIPTION["tu"] = {
  title: "Запрещение обновления времени по сигналам БС",
};
KEY_DESCRIPTION["wk"] = {
  title: "Пароль шифрования",
};
KEY_DESCRIPTION["ma"] = {
  title: "MAC-адрес",
};
KEY_DESCRIPTION["mb"] = {
  title: "MAC-адрес WiFi",
};

KEY_DESCRIPTION["ed"] = {
  title: "Режим работы после постановки на охрану",
};

KEY_DESCRIPTION["ti"] = {
  title: "Тип отображаемой информации на УВС",
};

KEY_DESCRIPTION["ks2"] = {
  title: "Старый ключ шифрования",
  description:
    "Ключ шифрования, используемый при необходимости заменить имеющийся в приборе, ранее установленный, ключ шифрования.",
};

KEY_DESCRIPTION["!!"] = {
  title: "Пароль удаленного управления",
  description:
    "Пароль для отправки SMS на прибор, а также в качестве «мастер кода», для конфигурирования устройства с клавиатуры. Для использования в качестве «мастер-кода» следует использовать только цифры.",
};

KEY_DESCRIPTION["ph1"] = {
  title: "Номер телефона",
  description:
    "Номера телефонов, установленных в прибор. Данные из этих полей являются справочными и не используются прибором в процессе работы. Данные используются  программой АРМ ДПУ «Юпитер» при добавлении прибора с использованием готового файла конфигурации, а также необходимы для отправки управляющих SMS сообщений.",
};
KEY_DESCRIPTION["ph2"] = {
  title: "Номер телефона",
  description:
    "Номера телефонов, установленных в прибор. Данные из этих полей являются справочными и не используются прибором в процессе работы. Данные используются  программой АРМ ДПУ «Юпитер» при добавлении прибора с использованием готового файла конфигурации, а также необходимы для отправки управляющих SMS сообщений.",
};

KEY_DESCRIPTION["cb1_0"] = {
  title: "Период опроса баланса SIM карты, ч.",
  description:
    "Периодичность опроса баланса соответствующей SIM карты. Период опроса может быть задан в в диапазоне от 1 до 48 часов. Задание периода '0' отключает опрос баланса(Рекомендуется для корпоративных SIM карт).",
};
KEY_DESCRIPTION["cb1_1"] = {
  title: "Код запроса баланса SIM карты",
  description:
    "Команда используемая для запроса баланса как самим прибором, так и при получении команды на опрос с пульта. ",
};

KEY_DESCRIPTION["pr"] = {
  title: "Извещение о переходе на 'резерв' по",
  description: "",
};

KEY_DESCRIPTION["sk"] = {
  title: "Кодировка смс-сообщений",
  description: "",
};

KEY_DESCRIPTION["mc"] = {
  title: "Выбор основного канала",
  description: "",
};
KEY_DESCRIPTION["bt"] = {
  title: "Разрешение работы конфигуратора прибора по Bluetooth",
  description: "",
};
KEY_DESCRIPTION["xxmn"] = {
  title: "MAC-адрес радиоканала",
  description: "",
};

KEY_DESCRIPTION["sg"] = {
  title: "Режим отправки СМС-сообщений совместно с LAN (GPRS)",
  description: "",
};

KEY_DESCRIPTION["cb2_0"] = {
  title: "Период опроса бланса SIM карты, ч.",
  description:
    "Периодичность опроса баланса соответствующей SIM карты. Период опроса может быть задан в в диапазоне от 1 до 48 часов. Задание периода '0' отключает опрос баланса(Рекомендуется для корпоративных SIM карт).",
};
KEY_DESCRIPTION["cb2_1"] = {
  title: "Код запроса баланса SIM карты",
  description:
    "Команда используемая для запроса баланса как самим прибором, так и при получении команды на опрос с пульта. ",
};

KEY_DESCRIPTION["ct1"] = {
  title: "Порог оповещения о низком балансе счета SIM карты",
  description:
    "При обнаружении в сообщении информации о том, что баланс доступных средств  на SIM карте снизился до заданного порога (первое число  в сообщении о состоянии баланса), прибор передает сообщение о том, что баланс меньше заданного.",
};
KEY_DESCRIPTION["ct2"] = {
  title: "Порог оповещения о низком балансе счета SIM карты",
  description:
    "При обнаружении в сообщении информации о том, что баланс доступных средств  на SIM карте снизился до заданного порога (первое число  в сообщении о состоянии баланса), прибор передает сообщение о том, что баланс меньше заданного.",
};



KEY_DESCRIPTION["ie"] = {
  title: "Канал связи",
  description: "",
};

KEY_DESCRIPTION["ha"] = { title: "Автоматическая проверка наличия обновления ПО" };
KEY_DESCRIPTION["ca"] = { title: "Число неудачных попыток связи перед переключением(1..20)" };
KEY_DESCRIPTION["lf"] = { title: "разрешено ведение LOG-файла" };
KEY_DESCRIPTION["es"] = { title: "При снятии сначала выполняется сброс пожарных шлейфов и сирены" };
KEY_DESCRIPTION["gi"] = { title: "Идентификатор устройства" };
KEY_DESCRIPTION["ks3"] = { title: "Пароль доступа к конфигурации (от 4 до 8 цифр)" };
KEY_DESCRIPTION["bv"] = { title: "Громкость встроеного зумера" };
KEY_DESCRIPTION["hs"] = { title: "URL сервера обновления ПО прибора" };
KEY_DESCRIPTION["sz"] = { title: "Привязка сирены к разделам" };
KEY_DESCRIPTION["st"] = { title: "Время работы сирены (1...999, 0 - выключена)" };
KEY_DESCRIPTION["im"] = { title: "Режим работы светодиодной индикации" };
KEY_DESCRIPTION["tp"] = { title: "Время обнаружения резервного питания" };
KEY_DESCRIPTION["el"] = { title: "Сброс индикации 'памяти тревог' после снятия через" };
KEY_DESCRIPTION["ci"] = { title: "Связи с ПЦО" };
KEY_DESCRIPTION["fp"] = { title: "Внешнего питания" };
KEY_DESCRIPTION["fb"] = { title: "АКБ" };
KEY_DESCRIPTION["gm1"] = { title: "Автоматическое определение настройки APN" };
KEY_DESCRIPTION["kr"] = { title: "Время восстановления КТС, сек." };
KEY_DESCRIPTION["km"] = { title: "Время индикации тревоги КТС, сек." };
KEY_DESCRIPTION["dc"] = { title: "Тревога по двойному нажатию" };
KEY_DESCRIPTION["gm2"] = { title: "Автоматическое определение настройки APN" };
KEY_DESCRIPTION["ga1"] = { title: "APN-сервер" };
KEY_DESCRIPTION["ga2"] = { title: "APN-сервер" };
KEY_DESCRIPTION["gl1"] = { title: "Логин" };
KEY_DESCRIPTION["gl2"] = { title: "Логин" };
KEY_DESCRIPTION["gp1"] = { title: "Пароль" };
KEY_DESCRIPTION["gp2"] = { title: "Пароль" };
KEY_DESCRIPTION["cm_0"] = { title: "Режим выбора SIM-карты" };
KEY_DESCRIPTION["cm_1"] = { title: "Время возврата на основную SIM-карту (1..24) (ч.)" };
KEY_DESCRIPTION["om"] = { title: "Периодичность отправки сообщений 'Дежурный режим' по каналу SMS (ч.)" /* "Периодичность отправки сообщений по всем каналам (ч.)" */ };
KEY_DESCRIPTION["on"] = { title: "Периодичность отправки сообщения по дозвону  (мин.)" };
KEY_DESCRIPTION["at1"] = { title: "Режим используемой GSM-антенны" };
KEY_DESCRIPTION["sn1_1"] = { title: "Sim 1" };
KEY_DESCRIPTION["sn2_1"] = { title: "Sim 2" };
KEY_DESCRIPTION["tc1_1"] = { title: "Нижний порог" };
KEY_DESCRIPTION["tc1_0"] = { title: "Верхний порог" };
KEY_DESCRIPTION["ow"] = { title: "Режим ТМ" };
KEY_DESCRIPTION["os"] = { title: "Секретный ключ, записываемый в DS1961" };
KEY_DESCRIPTION["ez"] = { title: "Разделы" };
KEY_DESCRIPTION["sm"] = { title: "Работа прибора по протоколу GPRS" };
KEY_DESCRIPTION["s_noused"] = { title: "Зона не контролируется, может принимать любое состояние" };
KEY_DESCRIPTION["s_guardDelay"] = {
  title:
    "Контролируется только когда раздел находится на охране; востановление зоны в процессе постановки на охрану, то раздел берется на охрану до истечения задержки на выход; зона формирует сигнал 'ТРЕВОГА' с задержкой, возможно формирование сигнала 'ВХОД' непосредственно при нарушении; число тревожных сообщений без перевзятия мождет быть ограничено.",
};
KEY_DESCRIPTION["s_guard"] = {
  title:
    "Контролируется только когда раздел находится на охране; зона формирует сигнал 'ТРЕВОГА' без задежки; число тревожных сообщений без перевзятия может быть ограничено",
};
KEY_DESCRIPTION["s_prohod"] = {
  title:
    "Формируется сообщение «Тревога». Не формируется сообщение «Тревога» на время отсчета задержки на вход или выход. Формируется сообщение «Тревога» по окончании задержки, если не происходит снятия с охраны",
};
KEY_DESCRIPTION["s_guardFixDelay"] = {
  title:
    "Контролируется только когда раздел находится на охране; - восстановление зоны в процессе постановки на охрану не приводит к ускоренному взятию; - зона формирует сигнал ТРЕВОГА с задержкой, возможно формирование сигнала ВХОД непосредственно при нарушении; - число тревожных сообщений без перевзятия может быть ограничено",
};
KEY_DESCRIPTION["s_KTS"] = {
  title:
    "контролируется при любом состоянии раздела; при нарушении формируется событие 'ТРЕВОГА (КТС)'; число тревожных сообщений не ограничено ",
};
KEY_DESCRIPTION["s_Fire"] = { title: "При нарушении зоны формируется сообщение 'Пожар' " };
KEY_DESCRIPTION["s_Patrul"] = { title: "при нарушении зоны формируется сообщение 'ПАТРУЛЬ' " };
KEY_DESCRIPTION["s_Water"] = { title: "При нарушении зоны формируется сообщение 'Утечка воды' " };
KEY_DESCRIPTION["s_Gaz"] = { title: "При нарушении зоны формируется сообщение 'Утечка газа' " };
KEY_DESCRIPTION["ut"] = { title: "Период обновления данных о позиционировании прибора" };

RS485 = {
  1: { title: "РШ Юпитер-3811 (4 ШС)", sensor: 4 },
  2: { title: "РШ Юпитер-3812 (8 ШС)", sensor: 8 },
  3: { title: "РШ Юпитер-3813 (16 ШС)", sensor: 16 },
  4: { title: "РР Юпитер-3214", sensor: 0 },
  5: { title: "УВС Юпитер-6134", sensor: 4 },
  6: { title: "УВС Юпитер-6135", sensor: 8 },
  7: { title: "УВС Юпитер-6136", sensor: 16 },
  8: { title: "УВС Сатурн-6137", sensor: 0 },
  9: { title: "УВС Сатурн-6138", sensor: 0 },
};

let RS485_RADIO = {
  1: { title: "РШ Юпитер-3811 (4 ШС)", sensor: 4 },
  2: { title: "РШ Юпитер-3812 (8 ШС)", sensor: 8 },
  3: { title: "РШ Юпитер-3813 (16 ШС)", sensor: 16 },
  4: "РР Юпитер-3214",
  5: "УВС Юпитер-6134",
  6: "УВС Юпитер-6135",
  7: "УВС Юпитер-6136",
  8: "УВС Сатурн-6137",
  9: "УВС Сатурн-6138",
};

let RS485_LIST = {
  1: "13811",
  2: "13812",
  3: "13813",
  4: "Расш. реле Ю-3214",
  5: "16134",
  6: "16135",
  7: "16136",
  8: "16145",
  9: "16138",
};

function listTypeSensors(type) {
  let newStr =
    '<select onchange="setTYPE_SENSORSchange(this)"> <option title="шлейф не контролируется, может принимать любое состояние" value="7"';
  if (type == 7) {
    newStr += " selected ";
  }
  newStr += ">Исключен, не контролируется</option>" + '<option style="background-color:lightgreen" value="1"';
  if (type == 1) {
    newStr += " selected ";
  }
  newStr +=
    "title=\"контролируется только когда раздел находится на охране; востановление шлейфа в процессе постановки на охрану, то раздел берется на охрану до истечения задержки на выход; шлейф формирует сигнал 'ТРЕВОГА' с задержкой, возможно формирование сигнала 'ВХОД' непосредственно при нарушении; число тревожных сообщений без перевзятия мождет быть ограничено.\">Охр. с задержкой (вход/выход)</option>" +
    '<option style="background-color:lightgreen" value="2"';
  if (type == 2) {
    newStr += " selected ";
  }
  newStr +=
    "title=\"контролируется только когда раздел находится на охране; шлейф формирует сигнал 'ТРЕВОГА' без задежки; число тревожных сообщений без перевзятия может быть ограничено \">Охранный</option>" +
    '<option style="background-color:lightgreen" value="4"';
  if (type == 4) {
    newStr += " selected ";
  }
  newStr +=
    'title="Формируется сообщение «Тревога». Не формируется сообщение «Тревога» на время отсчета задержки на вход или выход. Формируется сообщение «Тревога» по окончании задержки, если не происходит снятия с охраны">Охранный (проходная зона)</option>';

  newStr +=
    '<option style="background-color:lightgreen" title="- контролируется только когда раздел находится на охране; - восстановление шлейфа в процессе постановки на охрану не приводит к ускоренному взятию; - шлейф формирует сигнал ТРЕВОГА с задержкой, возможно формирование сигнала ВХОД непосредственно при нарушении; - число тревожных сообщений без перевзятия может быть ограничено" value="16"';
  if (type == 16) {
    newStr += " selected ";
  }
  newStr += ">Охр. с фикс. задержкой (вход/выход)</option>";

  newStr += '<option style="background-color:lightgreen" value="6" ';
  if (type == 6) {
    newStr += " selected ";
  }
  newStr +=
    "title=\"контролируется при любом состоянии раздела; при нарушении формируется событие 'ТРЕВОГА (КТС)'; число тревожных сообщений не ограничено \">Тревога/паника КТС</option>" +
    '<option style="background-color:indianred" value="8" title="При нарушении ШС формируется сообщение \'Пожар\' "';
  if (type == 8) {
    newStr += " selected ";
  }
  newStr += ">Пожарный</option>" + '<option value="14" style="background-color:lightskyblue"';
  if (type == 14) {
    newStr += " selected ";
  }
  newStr +=
    " title=\"при нарушении шлейфа формируется сообщение 'ПАТРУЛЬ' \">Контроль наряда</option>" +
    '<option value="17" title="При нарушении ШС формируется сообщение \'Утечка воды\' "';
  if (type == 17) {
    newStr += " selected ";
  }
  newStr +=
    ">Утечка воды</option>" + '<option value="18" title="При нарушении ШС формируется сообщение \'Утечка газа\' "';
  if (type == 18) {
    newStr += " selected ";
  }
  newStr += ">Утечка газа</option>";

  newStr += "</select>";

  return newStr;
}

function listPartitionSensors(partition) {
  const disabled = ` style='display:${partition === '0' ? 'none' : 'block'}'`
  let newStr = '<select' + disabled + 'onchange="setPARTITION_SENSORSchange(this)" id="yz' + partition + '" >';

  for (var i = 1; i <= DEVICEINFO[DEVICEMODEL].sections; i++) {
    newStr += '<option value="' + i + '" ';
    if (partition == i) {
      newStr += " selected ";
    }
    newStr += ">Раздел " + i + "</option>";
  }

  newStr += "</select>";

  return newStr;
}

function listFixedSensors(value) {
  let newStr = "<select name='lc' onchange='setLC_CONTROLchange(this)'>";
  newStr += '<option value="0"';
  if (value == 0) {
    newStr += " selected ";
  }
  newStr += ">автовосстановление после устранения нарушения</option>";
  newStr += '<option value="1"';
  if (value == 1) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 1 Тревоги</option>";

  newStr += '<option value="2"';
  if (value == 2) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 2 Тревоги</option>";

  newStr += '<option value="3"';
  if (value == 3) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 3 Тревоги</option>";

  newStr += '<option value="4"';
  if (value == 4) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 4 Тревоги</option>";

  newStr += '<option value="5"';
  if (value == 5) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 5 Тревоги</option>";

  newStr += '<option value="6"';
  if (value == 6) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 6 Тревоги</option>";

  newStr += '<option value="7"';
  if (value == 7) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 7 Тревоги</option>";

  newStr += '<option value="8"';
  if (value == 8) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 8 Тревоги</option>";

  newStr += '<option value="9"';
  if (value == 9) {
    newStr += " selected ";
  }
  newStr += " >зафиксировать в Тревоге, после 9 Тревоги</option>";
  newStr += "</select>";
  return newStr;
}
function verElestaToInt(s) {
  let code = 0
  s.toLowerCase().split('').forEach((symbol) => {
    if (symbol !== '.') {
      code <<= 8
      code += symbol.charCodeAt(0);
    }
  })
  return code
}

function findCurrentVersion() {
  let currentVersion = ''
  for (j in deviceJSON.config) {
    if (deviceJSON.config[j].key == 'sv') {
      currentVersion = deviceJSON.config[j].subvalues[0].value +
        deviceJSON.config[j].subvalues[1].value
    }
  }

  if (currentVersion === '') {
    currentVersion = currentCoreVersion.replace('.', '')
  }

  return currentVersion
}


function listTypeOk(value, key) {
  //  САТУРНЫ


  const _minNewVersion = '0.1N'
  let currentVersion = findCurrentVersion()


  let str = ''
  switch (key) {
    case "v3":
      str = "<select name='oc' onchange='setOC_CONTROL_TYPEchange(this, `oc`)'>";
      break;
    case "TF":
      str = "<select name='tf' onchange='setOC_CONTROL_TYPEchange(this, `tf`)'>";
      break;

    default:
      str = "<select name='oc' onchange='setOC_CONTROL_TYPEchange(this, `oo`)'>"
      break;
  }


  if (saturnDevice.includes(DEVICEMODEL) && verElestaToInt(_minNewVersion) > verElestaToInt(currentVersion) && currentVersion !== '-1' && currentVersion !== '') {
    // old version saturn
    str += '<option value="12" ';
    if (value == 12) {
      str += " selected ";
    }
    str += ">Не используется</option>";
    str += '<option style="background:lightgreen" value="1" ';
    if (value == 1) {
      str += " selected ";
    }
    str += ">Транспарант - Охрана</option>";
    str += '<option style="background:lightgreen" value="2" ';
    if (value == 2) {
      str += " selected ";
    }
    str += ">Лампа</option>";
    str += '<option style="background:lightgreen" value="3" ';
    if (value == 3) {
      str += " selected ";
    }
    str += ">Сирена 1</option>";

    str += '<option style="background:lightgreen" value="4" ';
    if (value == 4) {
      str += " selected ";
    }
    str += ">Сирена 2</option>";
    str += '<option style="background:lightskyblue" value="11" ';
    if (value == 11) {
      str += " selected ";
    }
    str += ">Импульс</option>";
    str += "</select>";
  }
  else {

    str += '<option value="12" ';
    if (value == 12) {
      str += " selected ";
    }
    str += ">Не используется</option>";
    if (!saturnDevice.includes(DEVICEMODEL)) {
      str += '<option style="background:lightgreen" value="0" ';
      if (value == '0') {
        str += " selected ";
      }
      str += ">SMS</option>";
      str += '<option style="background:lightgreen" value="1" ';
      if (value == 1) {
        str += " selected ";
      }
      str += ">ПЦН - Охрана</option>";


    }

    str += '<option style="background:lightgreen" value="2" ';
    if (value == 2) {
      str += " selected ";
    }
    str += ">Транспарант - Охрана</option>";

    str += '<option style="background:lightgreen" value="3" ';
    if (value == 3) {
      str += " selected ";
    }
    str += ">Лампа</option>";

    str += '<option style="background:lightgreen" value="4" ';
    if (value == 4) {
      str += " selected ";
    }
    str += ">Сирена 1</option>";

    str += '<option style="background:lightgreen" value="5" ';
    if (value == 5) {
      str += " selected ";
    }
    str += ">Сирена 2</option>";

    if (DEVICEMODEL.slice(-4) === '2022' || DEVICEMODEL.slice(-2) === 'v2') {
      str += '<option style="background:lightcoral" value="6" ';
      if (value == 6) {
        str += " selected ";
      }
      str += ">ПЦН - Пожар</option>";

      str += '<option style="background: lightcoral" value="7" ';
      if (value == 7) {
        str += " selected ";
      }
      str += ">Транспарант - Пожар</option>";

      str += '<option style="background:lightcoral" value="8" ';
      if (value == 8) {
        str += " selected ";
      }
      str += ">Сирена 1 - Пожар</option>";

      str += '<option style="background:lightcoral" value="9" ';
      if (value == 9) {
        str += " selected ";
      }
      str += ">Сирена 2 - Пожар</option>";
    }
    if (!saturnDevice.includes(DEVICEMODEL)) {
      str += '<option style="background:lightskyblue" value="10" ';
      if (value == 10) {
        str += " selected ";
      }
      str += ">Замок</option>";
    }
    str += '<option style="background:lightskyblue" value="11" ';
    if (value == 11) {
      str += " selected ";
    }
    str += ">Импульс</option>";
    str += "</select>";
  }
  return str;
}


function unlockXXSSinput(elem) {

  if (elem.value == "12") {
    backToNumberAdres(elem.id);
    if (elem.id == "pv_triger_mod") {
      // Блокировки зависят от ПВ


      document.getElementById("pv_delay").value = '1';

      document.getElementById("XXSS_power_12").disabled = true;
      document.getElementById("XXSS_power_24").disabled = true;
      document.getElementById("XXSS_break_true").disabled = true;
      document.getElementById("XXSS_break_false").disabled = true;
      document.getElementById("XXSS_power_12").checked = true;
      document.getElementById("XXSS_power_24").checked = false;
      document.getElementById("XXSS_break_true").checked = false;
      document.getElementById("XXSS_break_false").checked = true;
      if (document.getElementById("XXSS_tamper_control")) {
        document.getElementById("XXSS_tamper_control").checked = true;
      }

    }

    if (elem.id == "pv_triger_mod") {
      localStorage.setItem('tmpPV', document.getElementById("number_PV").value)
      document.getElementById("number_PV") ? (document.getElementById("number_PV").value = 0) : "";
    } else if (elem.id == "rv_triger_mod") {
      document.getElementById("rv_delay").value = '0';
      localStorage.setItem('tmpRV', document.getElementById("number_RV").value)
      document.getElementById("number_RV") ? (document.getElementById("number_RV").value = 0) : "";
    } else {
      console.error(elem.id);
    }
  }
  else {
    if (elem.id == "pv_triger_mod") {
      // Блокировки зависят от ПВ
      document.getElementById("XXSS_power_12").disabled = false;
      document.getElementById("XXSS_power_24").disabled = false;
      document.getElementById("XXSS_break_true").disabled = false;
      document.getElementById("XXSS_break_false").disabled = false;
      if (document.getElementById("XXSS_tamper_control")) {
        document.getElementById("XXSS_tamper_control").disabled = false;
      }

    }
    if (elem.id == "pv_triger_mod") {
      let tmpPV = localStorage.getItem('tmpPV')
      document.getElementById("number_PV").value == 0
        ? document.getElementById("number_PV")
          ? (document.getElementById("number_PV").value = String(pickUpOeOhNrNu()[0]))
          : ""
        : "";
    } else if (elem.id == "rv_triger_mod") {
      let tmpRV = localStorage.getItem('tmpRV')
      document.getElementById("number_RV").value == 0
        ? document.getElementById("number_RV")
          ? (document.getElementById("number_RV").value = String(pickUpOeOhNrNu()[1]))
          : ""
        : "";
    } else {
      console.error(elem.id);
    }
  }
}

function backToNumberAdres(cucumber) {
  // Отчищаем virtualExeAll от временого адреса
  let id = CACHE_EDIT_R_DEVICE.id;
  let numberExe;
  if (cucumber == "pv_triger_mod") {
    numberExe = document.getElementById("number_PV").value;
  } else {
    numberExe = document.getElementById("number_RV").value;
  }

  for (var i = 0; i < virtualExeAll.length; i++) {
    if (virtualExeAll[i].numberExe == numberExe) {
      virtualExeAll[i].temp = false;
    }
  }
}

function pickUpFreeOO(nameKey, zone) {
  let freeNumber; // массив подобранных свободных ключей
  let lengthKey = nameKey.length;
  let complect = false;
  // if (CACHE_EDIT_R_DEVICE.id == "-1") {
  //   // создание нового ркпс устрйоства
  //   for (i in deviceJSON.config) {
  //     if (deviceJSON.config[i].key.indexOf(nameKey) != -1) {
  //       if (deviceJSON.config[i].subvalues[0].value == "0" && deviceJSON.config[i].subvalues[1].value == "0") {
  //         deviceJSON.config[i].key.slice(lengthKey) != 1
  //           ? freeNumber.push(deviceJSON.config[i].key.slice(lengthKey))
  //           : "";
  //       }
  //     }
  //   }
  // } else {
  // редактирование карточки

  for (var i = 0; i < virtualExeAll.length; i++) {
    if (virtualExeAll[i].numberDeviceExe == "" && virtualExeAll[i].temp == false) {
      freeNumber = virtualExeAll[i].numberExe;
      virtualExeAll[i].temp = true;
      complect = !complect;
      break;
    }
  }
  /*
    for (k in virtualRadio) {
      if (virtualRadio[k].numberRadio == CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[k].PV[0] == "0") {
          // В памяти нет номера зоны ПВ
          for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf(nameKey) != -1) {
              if (deviceJSON.config[i].subvalues[0].value == "0" && deviceJSON.config[i].subvalues[1].value == "0") {
                deviceJSON.config[i].key.slice(lengthKey) != 1
                  ? freeNumber.push(deviceJSON.config[i].key.slice(lengthKey))
                  : "";
              }
            }
          }
        } else {
          // В памяти ЕСТЬ номер зоны ПВ
          freeNumber[0] = virtualRadio[k].PV[0];
        }
        if (virtualRadio[k].RV[0] == "0") {
          // В памяти нет номера зоны РВ
          for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf(nameKey) != -1) {
              if (deviceJSON.config[i].subvalues[0].value == "0" && deviceJSON.config[i].subvalues[1].value == "0") {
                deviceJSON.config[i].key.slice(lengthKey) != 1
                  ? freeNumber.push(deviceJSON.config[i].key.slice(lengthKey))
                  : "";
              }
            }
          }
        } else {
          // В памяти ЕСТЬ номер зоны РВ
          freeNumber[1] = virtualRadio[k].RV[0];
        }
        
        //freeNumber.push(virtualRadio[i].PV[0]);
        //freeNumber.push(virtualRadio[i].RV[0]);
      }
    }  */
  // }

  if (complect) {
    return freeNumber;
  } else {
    closeModalR_dev();
    document.getElementById("modal_error_text").innerHTML = "Превышено максимальное количество исполнительных устроств";
    $.modal("#modal_error_core");
  }
}

function listTypeExe(value, number, id, numberIndexExe, who, typeDev) {

  // РКПС 208
  let func = "";
  let idDom = "";
  if (numberIndexExe === "ПВ") {
    if (who === "modal") {
      idDom = "pv_triger_mod";
    }
  }
  if (numberIndexExe === "РВ") {
    if (who === "modal") {
      idDom = "rv_triger_mod";
    }
  }

  if (id !== "-1") {
    if (typeDev === 'integralExe') {
      func = "onchange='setOO_CONTROL_TYPEchangeExe(this)'";
    } else {
      func = "onchange='setOO_CONTROL_TYPEchange(this)'";
    }

  } else {
    //if (numberIndexExe === "ПВ") {
    func = "onchange='unlockXXSSinput(this)'";
    // }
  }
  if (CACHE_EDIT_R_DEVICE.id == "-1") {
    value = "12";
  }

  let str = "<select";
  if (number === '0' && who === 'table') {
    str += " disabled ";
  }
  str += " class='ooWork_ext4'  id='" + idDom + "'  name='" + number + "' " + func + " >";
  str += '<option value="12" ';
  if (value == 12) {
    str += " selected ";
  }
  str += ">Не используется</option>";
  if (numberIndexExe !== "ПВ") {
    str += '<option value="0" ';
    if (value == '0') {
      str += " selected ";
    }
    str += ">SMS</option>";

    str += '<option value="1" ';
    if (value == 1) {
      str += " selected ";
    }
    str += ">ПЦН - Охрана</option>";

    str += '<option value="2" ';
    if (value == 2) {
      str += " selected ";
    }
    str += ">Транспарант - Охрана</option>";

    str += '<option value="3" ';
    if (value == 3) {
      str += " selected ";
    }
    str += ">Лампа</option>";
  }
  str += '<option value="4" ';
  if (value == 4) {
    str += " selected ";
  }
  str += ">Сирена 1</option>";

  str += '<option value="5" ';
  if (value == 5) {
    str += " selected ";
  }
  str += ">Сирена 2</option>";

  // str += '<option value="6" ';
  // if (value == 6) {
  //     str += " selected ";
  // }
  // str += ">ПЦН - Пожар</option>";

  // str += '<option value="7" ';
  // if (value == 7) {
  //     str += " selected ";
  // }
  // str += ">Транспарант - Пожар</option>";

  // str += '<option value="8" ';
  // if (value == 8) {
  //     str += " selected ";
  // }
  // str += ">Сирена 1 - Пожар</option>";

  // str += '<option value="9" ';
  // if (value == 9) {
  //     str += " selected ";
  // }
  // str += ">Сирена 2 - Пожар</option>";
  if (numberIndexExe !== "ПВ") {
    str += '<option value="10" ';
    if (value == 10) {
      str += " selected ";
    }
    str += ">Замок</option>";
  }
  str += '<option value="11" ';
  if (value == 11) {
    str += " selected ";
  }
  str += ">Импульс</option>";

  str += '<option value="13" ';
  if (value == 13) {
    str += " selected ";
  }
  str += ">Контроль наряда</option>";

  if (typeDev === 'integralExe' && (DEVICEMODEL.indexOf("208") != -1 || DEVICEMODEL.slice(0, 5).indexOf("202") != -1)) {
    str += '<option value="14" ';
    if (value == 14) {
      str += " selected ";
    }
    str += ">Выносной индикатор</option>";
  }
  str += '<option value="15" ';
  if (value == 15) {
    str += " selected ";
  }
  str += ">Радиолампа</option>";
  str += "</select>";
  if (number === '0' && who === 'table') {
    str = `<div onclick='open_modal_thisDeviceExit(this.name)'>${str}</div>`;
  }
  return str;
}

function listTypeOw(value) {
  let str = ' <select onchange="setOwControl(this)" style="width:100%"><option value="0" ';
  if (value == 0) {
    str += " selected ";
  }
  str += ' >без защиты от копирования+УВС-ТМ (любого типа)</option><option value="1" ';
  if (value == 1) {
    str += " selected ";
  }
  str += " >с защитой от копирования+УВС-ТМ (адресный)</option></select>";
  return str;
}

function listTypeUa(value) {
  let str = "";
  if (DEVICEMODEL !== "J2320" && DEVICEMODEL !== "J2321" && DEVICEMODEL !== "J2326") {
    str = "<select disabled>";
    str += "<option";
    value == "1" ? (str += " selected ") : "";
    str += ' value="1">Постановка/Снятие</option>';
    str += "<option";
    value == "2" ? (str += " selected ") : "";
    str += ' value="2">Принуждение</option>';
    str += "<option";
    value == "3" ? (str += " selected ") : "";
    str += ' value="3">Контроль наряда</option>';
    str += "<option";
    value == "4" ? (str += " selected ") : "";
    str += ' value="4">Включение выхода управления</option>';
    str += "<option";
    value == "5" ? (str += " selected ") : "";
    str += ' value="5">Сервис</option>';

    str += "<option";
    value == "7" ? (str += " selected ") : "";
    str += ' value="7">Только постановка</option>';

    str += "<option";
    value == "8" ? (str += " selected ") : "";
    str += ' value="8">Только снятие</option>';
    str += "</select>";
  } else {
    // ТК
    str = "<select disabled>";
    str += "<option";
    value == "1" ? (str += " selected ") : "";
    str += ' value="1">Сброс КТС</option>';
    str += "<option";
    value == "3" ? (str += " selected ") : "";
    str += ' value="3">Контроль наряда</option>';
    str += "</select>";
  }

  return str;
}

let TYPE_RADIO_DEVICE = {
  2: "Охранный",
  5: "Пожарный",
};

let TYPE_ZONE_DEVICE = {
  0: "-",
  1: "Не используется",
  2: "Технологическая",
  3: "Управляющая",
  4: "Пожарная",
  5: "Охранная",
};

let R_DEVICE_NAME = {
  0: {
    name: "Не выбран",
    type: "20",
    zone: "1",
    description:
      "<details id='detailsCard' open><summary><b>Описание</b></summary> <h3>Инфракрасный извещатель  «Юпитер 5231»</h3> Основные возможности: <ul> <li> Устойчивость к движению животных весом до 40 кг; </li>   <li>Температурная компенсация порогов срабатывания; </li> <li>  Автотестирование; </li><li>   Устойчивость к засветке более 8500 Лк;  </li><li>  ЭМС 4-ая степень жесткости; </li></ul>       Особенности:    <ul style='margin:0;'><li>Удобство инсталяции;  </li><li>  Безвинтовая регулировка наклона зоны обнаружения;   </li><li> Встроенный датчик 'вскрытия/отрыва' корпуса;</li></ul></details>",
  }, 1: {
    name: "ВСЕ",
    type: "20",
    zone: "1",
    description: ''
    // "<details id='detailsCard' open><summary><b>Описание</b></summary> <h3>Инфракрасный извещатель  «Юпитер 5231»</h3> Основные возможности: <ul> <li> Устойчивость к движению животных весом до 40 кг; </li>   <li>Температурная компенсация порогов срабатывания; </li> <li>  Автотестирование; </li><li>   Устойчивость к засветке более 8500 Лк;  </li><li>  ЭМС 4-ая степень жесткости; </li></ul>       Особенности:    <ul style='margin:0;'><li>Удобство инсталяции;  </li><li>  Безвинтовая регулировка наклона зоны обнаружения;   </li><li> Встроенный датчик 'вскрытия/отрыва' корпуса;</li></ul></details>",
  },
  15231: {
    name: "ИК Ю-5231",
    type: "2",
    zone: "1",
    description:
      "<details id='detailsCard' open><summary><b>Инфракрасный извещатель  «Юпитер 5231»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/5231.png'></td><td style='width:80%'><i>Основные возможности:</i> <ul style='margin:0;'> <li> Устойчивость к движению животных весом до 40 кг; </li>   <li>Температурная компенсация порогов срабатывания; </li> <li>  Автотестирование; </li><li>   Устойчивость к засветке более 8500 Лк;  </li><li>  ЭМС 4-ая степень жесткости; </li></ul>      <i> Особенности: </i>    <ul style='margin:0;'><li>Удобство инсталяции;  </li><li>  Безвинтовая регулировка наклона зоны обнаружения;   </li><li> Встроенный датчик 'вскрытия/отрыва' корпуса;</li></ul></table></details>",
  },
  15230: {
    name: "ИК Ю-5230",
    type: "2",
    zone: "1",
    description:
      "<details id='detailsCard' open><summary><b>Инфракрасный извещатель  «Юпитер 5230»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/5230.png'></td><td style='width:80%'><i> Основные возможности:</i>  <ul style='margin:0;'> <li>  Температурная компенсация порогов срабатывания;  </li>   <li>  Автотестирование;   </li>   <li> Устойчивость к засветке более 8500 Лк; </li>   <li>    ЭМС 4-ая степень жесткости;   </li></ul>  <i>  Особенности: </i>   <ul style='margin:0;'><li> Удобство инсталяции;  </li><li>  Безвинтовая регулировка наклона зоны обнаружения; </li><li>   Встроенный датчик 'вскрытия/отрыва' корпуса;</li></ul></td></tr></table> </details>",
  },
  15130: {
    name: "МК Ю-5130",
    type: "2",
    zone: "2",
    description:
      "<details id='detailsCard' open><summary><b>Извещатель универсальный магнито-контактный  «Юпитер 5130»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/5130.png'></td><td style='width:80%'> <i> Основные возможности:  </i>   <ul style='margin:0;'> <li>  Вход для подключения внешнего проводного охранного    извещателя;   </li>   <li>   Отключаемая индикация тревоги;    </li></ul>    <i>  Особенности: </i>   <ul style='margin:0;'> <li>  Антисаботаж (2 датчика Холла);  </li>   <li>   Высокая помехоустойчивость;   </li>   <li>  Встроенный датчик 'вскрытия/отрыва' корпуса;   </li>   <li>  Удобство инсталяции;</li></ul></td></tr></table> </details>",
  },
  15830: {
    name: "АК Ю-5830",
    type: "2",
    zone: "2",
    description:
      "<details id='detailsCard' open><summary><b>Извещатель охранный поверхностный акустический «Юпитер 5830»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/5830.png'></td><td style='width:80%'><i>Основные возможности: </i> <ul style='margin:0;'> <li>  Высокая точность обнаружения; </li>   <li>  Дискретная регулировка чувствительности; </li>   <li>  Режим контроля выпадения осколков; </li>   <li>  Автотестирование;</li></ul> </td></tr></table></details>",
  },
  16270: {
    name: "Кл Ю-6270",
    type: "2",
    zone: "1",
    description: "<details id='detailsCard' open><summary><b>Автономная радио клавиатура «Юпитер 6270»</b></summary><table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/6270.png' style=width:190px; height:220px></td> <td style='width:80%'><i>Основные возможности: </i> <ul style='margin:0;'> <i> передача в РКПС   команд: </i>   <li>   Взятие Раздела (списка разделов) под охрану; </li>   <li>  Снятие Раздела (списка разделов)  с охраны; </li>   <li>  Запрос текущего состояния раздела (списка разделов);</li> <li> индикация процессов задержки постановки и снятия;</li> <li>  отображение текущего состояния раздела (списка разделов);</li><li>  отображение памяти о тревогах Зонах;</li> <i>Особенности: </i> <li> питание от двух батарей с автоматическим отключением неисправной;</li><li> пиндикация состояния питания;</li>    </ul> </td></tr></table></details > ",
  },
  16370: {
    name: "Бр Ю-6370",
    type: "2",
    zone: "4",
    description:
      "<details id='detailsCard' open><summary><b>Брелок Ю-6370</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/6370/6370.png'></td><td style='width:80%'><i>Основные возможности:</i> <ul style='margin:0;'> <li> Двухцветный светодиодный индикатор; </li>   <li>Индикация разряда батарейки; </li> <li>  4 кнопки имеют возможности настройки функционала; </li><li>   Питание: одна литиевая батарейка CR2032;  </li><li>  Входит в состав радиоканальной системы «Юпитер-868-ОТС», не более 14 шт. на систему. </li></ul>      <i> Особенности: </i>    <ul style='margin:0;'><li>Максимальная дальность радиосвязи в открытом пространстве – не менее 300м;  </li><li>  Время работы от одной батарейки, не менее 1 года;   </li><li> Диапазон рабочих температур - от -10 до +50;</li><li>Габариты: 67х40х15</li><li>Масса – не более  0,035 кг</li></ul></table></details>",
  },
  17620: {
    name: "ИУ Ю-7620",
    type: "2",
    zone: "2",
    description:
      "<details id='detailsCard' open><summary><b>Исполнительное устройство «Юпитер-7620»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/3431.png'></td><td style='width:80%'><i>Основные возможности:</i> <ul style='margin:0;'> <li> Два исполнительных выхода: потенциальный и релейный;</li> <li>Напряжение потенциального выхода 12 или 24В по выбору пользователя;</li>   <li>Контроль разряда батарей;</li> <li>Контроль состояния цепи питания нагрузки; </li><li> Контроль температуры; </li><li> Контроль вскрытия корпуса; </li><li>Связь по радиоканалу в радиоканальной системе «Юпитер-868 ОТС»</li></ul>      <i> Особенности: </i>    <ul style='margin:0;'><li>Полностью автономное исполнительное устройство: батарейное питание как управляющей так и исполнительной части устройства; </li><li>  Переключение на исполнительную батарею как на резервную при разряде основной батареи.</li></ul></table></details>",
  },
  13431: {
    name: "РО Ю-3431",
    type: "2",
    zone: "0",
    description:
      "<details id='detailsCard' open><summary><b>Ретранслятор объектовый «Юпитер-3431»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/3431.png'></td><td style='width:80%'><i>Основные возможности:</i> <ul style='margin:0;'> <li> Контроль вскрытия корпуса; </li>   <li>Контроль перемещения корпуса; </li> <li>  Динамически изменяемая топология сети, т. е. ретранслятор не имеет жестко заданного списка извещателей; </li><li>   Входит в состав радиоканальной системы «Юпитер-868-ОТС», не более 3 шт. на систему.  </li></ul>      <i> Особенности: </i>    <ul style='margin:0;'><li>Диапазон рабочих температур - от -30 до +50. </li><li>  Максимальная дальность радиосвязи в открытом пространстве – не менее 300м;   </li><li> Напряжение питания прибора: от 10,2 до 13,8 В;</li><li>Ток потребления – не более 150 мА;</li><li>Габариты: 105x70x30 мм;</li><li>Масса – не более 0,12 кг.</li></ul></table></details>",
  },

  13438: {
    name: "РО Ю-3438",
    type: "2",
    zone: "0",
    description:
      "<details id='detailsCard' open><summary><b>Ретранслятор объектовый «Юпитер-3438»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/3431.png'></td><td style='width:80%'><i>Основные возможности:</i> <ul style='margin:0;'> <li> Контроль вскрытия корпуса; </li>   <li>Контроль перемещения корпуса; </li> <li>  Динамически изменяемая топология сети, т. е. ретранслятор не имеет жестко заданного списка извещателей; </li><li>   Входит в состав радиоканальной системы «Юпитер-868-ОТС», не более 3 шт. на систему.  </li></ul>      <i> Особенности: </i>    <ul style='margin:0;'><li>Диапазон рабочих температур - от -30 до +50. </li><li>  Максимальная дальность радиосвязи в открытом пространстве – не менее 300м;   </li><li> Напряжение питания прибора: от 10,2 до 13,8 В;</li><li>Ток потребления – не более 150 мА;</li><li>Габариты: 105x70x30 мм;</li><li>Масса – не более 0,12 кг.</li></ul></table></details>",
  },

  13439: {
    name: "РО Ю-3439",
    type: "2",
    zone: "0",
    description:
      "<details id='detailsCard' open><summary><b>Ретранслятор объектовый «Юпитер-3439»</b></summary> <table style='width:100%; font-size:small'><tr></td><td style='text-align:left; vertical-align:middle;'><img src='images/3431.png'></td><td style='width:80%'><i>Основные возможности:</i> <ul style='margin:0;'> <li> Контроль вскрытия корпуса; </li>   <li>Контроль перемещения корпуса; </li> <li>  Динамически изменяемая топология сети, т. е. ретранслятор не имеет жестко заданного списка извещателей; </li><li>   Входит в состав радиоканальной системы «Юпитер-868-ОТС», не более 3 шт. на систему.  </li></ul>      <i> Особенности: </i>    <ul style='margin:0;'><li>Диапазон рабочих температур - от -30 до +50. </li><li>  Максимальная дальность радиосвязи в открытом пространстве – не менее 300м;   </li><li> Напряжение питания прибора: от 10,2 до 13,8 В;</li><li>Ток потребления – не более 150 мА;</li><li>Габариты: 105x70x30 мм;</li><li>Масса – не более 0,12 кг.</li></ul></table></details>",
  },
};

// UA index-1
// 1 — постановка/снятие
// 2 — принуждения
// 3 — патруль
// 4 — управление ОК
// Index 2 -  псевдоним пользователя
// Index 3 -  код пользователя
