function pk4_render_gsm() {
    // Вывод таблицы GSM дозвона
    THIS_DEVICE.gsmPhone.sort(compareSect);
    let str = '<table class="w3-table w3-table-all">';
    str += '<tr>';
    str += '<td>№</td>'
    str += '<td>Номер телефона</td>'
    str += '<td>Режим выполнения звонков</td>'
    str += '</tr>';

    for (var i = 0; i < THIS_DEVICE.gsmPhone.length; i++) {
        str += '<tr>'
        str += '<td>' + THIS_DEVICE.gsmPhone[i].number + '</td>';
        str += '<td><input onchange="setNewTypeGSM_phone(this)" name="' + THIS_DEVICE.gsmPhone[i].number + '" value="' + THIS_DEVICE.gsmPhone[i].phone + '"></td>';
        str += '<td>' + pk4_device_gsm_phone(THIS_DEVICE.gsmPhone[i].mode, THIS_DEVICE.gsmPhone[i].number) + '</td>';
        str += '</tr>'
    }

    str += '</table>';
    document.getElementById('tab_gsm_call_pk4_dn').innerHTML = str;
}

function pk4_device_gsm_phone(value, number) {
    let numberType
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === 'ds') {
            numberType = deviceJSON.config[i].subvalues[0].value   //Тип            

        }
    }
    // Режим выполнения звонков
    let str = '';
    if (numberType === '0') {
        str += '<select style="width:500px" onchange="setNewTypeGSM_phone_type(this)" name="' + number + '">';
        str += '<option value="0" '; if (value === '0') str += ' selected '; str += '>Телефон не используется</option>';
        str += '<option style="background:lightcoral" value="1" '; if (value === '1') str += ' selected '; str += '>ТРЕВОЖНЫЕ (дозвон с соединением: CSD)</option>';
        str += '<option style="background:lightcoral" value="2" '; if (value === '2') str += ' selected '; str += '>ТРЕВ. + СЛУЖЕБНЫЕ(для тревог:CSD, служебные:CSD)</option>';
        str += '<option style="background:lightcoral" value="3" '; if (value === '3') str += ' selected '; str += '>ТРЕВ.+ВЗЯТИЯ/СНЯТИЯ(для тревог:CSD,ВЗ/CH:CSD)</option>';
        str += '<option style="background:lightcoral" value="4" '; if (value === '4') str += ' selected '; str += '>ВСЕ (дозвон с соединением: CSD)</option>';


    }
    else if (numberType === '1') {
        str += '<select style="width:500px" onchange="setNewTypeGSM_phone_type(this)" name="' + number + '">';
        str += '<option value="0" '; if (value === '0') str += ' selected '; str += '>Телефон не используется</option>';
        str += '<option style="background:lightcoral" value="1" '; if (value === '1') str += ' selected '; str += '>ТРЕВОЖНЫЕ (сначала - ГОЛОС, затем CSD)</option>';
        str += '<option style="background:lightcoral" value="2" '; if (value === '2') str += ' selected '; str += '>ТРЕВ. + СЛУЖЕБНЫЕ (для тревог:ГОЛОС->CSD,служебные:CSD)</option>';
        str += '<option style="background:lightcoral" value="3" '; if (value === '3') str += ' selected '; str += '>ТРЕВ.+ВЗЯТИЯ/СНЯТИЯ(для тревог:ГОЛОС->CSD,ВЗ/CH:CSD)</option>';
        str += '<option style="background:lightcoral" value="4" '; if (value === '4') str += ' selected '; str += '>ВСЕ (для тревог: ГОЛОС->CSD, прочие: CSD)</option>';


    }
    else if (numberType === '2' || !numberType) {
        str += '<select  style="width:500px" onchange="setNewTypeGSM_phone_type(this)" name="' + number + '">';
        str += '<option value="0" '; if (value === '0') str += ' selected '; str += '>Телефон не используется</option>';
        str += '<option style="background:lightcoral" value="1" '; if (value === '1') str += ' selected '; str += '>ТРЕВОЖНЫЕ  (дозвон без соединения: ГОЛОС)</option>';
        str += '<option style="background:lightcoral" value="2" '; if (value === '2') str += ' selected '; str += '>ТРЕВ.(ГОЛОС),   СЛУЖЕБНЫЕ - игнорируются </option>';
        str += '<option style="background:lightcoral" value="3" '; if (value === '3') str += ' selected '; str += '>ТРЕВ.(ГОЛОС), ВЗЯТИЯ/СНЯТИЯ - игнорируются</option>';
        str += '<option style="background:lightcoral" value="4" '; if (value === '4') str += ' selected '; str += '>ВСЕ (ГОЛОС), прочие - игнорируются</option>';


    }
    if(THIS_DEVICE.model === 'J6422' || THIS_DEVICE.model === 'J6423'){
        str= ''
         str += '<select  style="width:500px" onchange="setNewTypeGSM_phone_type(this)" name="' + number + '">';
        str += '<option value="0" '; if (value === '0') str += ' selected '; str += '>Телефон не используется</option>';
        str += '<option style="background:lightcoral" value="1" '; if (value === '1') str += ' selected '; str += '>ТРЕВОЖНЫЕ  (дозвон без соединения: ГОЛОС)</option>';
    }

    str += '<option style="background:lightgreen" value="5" '; if (value === '5') str += ' selected '; str += '>ВЗЯТИЯ (дозвон без соединения: ГОЛОС)</option>';
    str += '<option style="background:lightgreen" value="6" '; if (value === '6') str += ' selected '; str += '>СНЯТИЯ (дозвон без соединения: ГОЛОС)</option>';
    str += '<option style="background:lightblue" value="7" '; if (value === '7') str += ' selected '; str += '>ДЕЖУРНЫЙ РЕЖИМ (дозвон без соединения: ГОЛОС)</option>';
    str += '</select>';
    return str

}

function setNewTypeGSM_phone_type(data) {
    // Смена типа Режим выполнения звонков
    let key = 'dn' + data.name;
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
            deviceJSON.config[i].subvalues[0].value = data.value; //Тип            
            saveConfig(deviceJSON.config[i]);
        }
    }
}

function setNewTypeGSM_phone(data) {
    // Смена номера телефона
    let key = 'dn' + data.name;
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == key) {
            deviceJSON.config[i].subvalues[1].value = data.value; //Тип            
            saveConfig(deviceJSON.config[i]);
        }
    }
}